/*
	Away System Modification - A new Away System for Miranda IM
	Copyright (C) 2004-2005 Iksaif Entertainment
	Copyright (C) 2002-2003 Goblineye Entertainment

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
  Thanx to Faith Healer for icons and help, Unregistered for his plugins (variables, AAA :p),
   mistag for GamerStatus,  BigMuscle for his code to use AAA
  Thanx to Tornado, orignal developer of AwaySys.
  Please note that some code from the Miranda's original away module (SRAway) is used around
  AwaySys. I tried to mention it wherever possible, but I might have forgotten a few. Kudos to Miranda's authors.
  The Read-Away-Msg part was practically copied from Miranda, not proud of it, but since I really can't see how can I make it better, there
  was no point in rewriting it all.
*/

#include "AwaySys.h"

HINSTANCE g_hInstance;
PLUGINLINK *pluginLink;
// Miranda used to be subclassed by Miranda back when 
//HWND g_hwndMiranda = NULL;
//WNDPROC g_OrigWP = NULL;
HWND g_hWndAwayDlg = NULL;
HANDLE g_hmModLoad = NULL, g_hmOptInit = NULL, g_hmStatChange = NULL, g_hmIdleChange = NULL, g_hmStatMsgReq = NULL, g_hmEventAdd = NULL;
HANDLE g_hmShutdown = NULL, g_hmIconsChanged = NULL, g_hmPreBuildMenu = NULL;
HANDLE g_hContactMenuItem = NULL, g_hReadStatMenuItem = NULL;
HANDLE g_hTopToolbarbutton = NULL, g_hmToolbarLoaded = NULL;
HANDLE g_hToggleSOEMenuItem = NULL;
WNDPROC g_OrigEditMsgProc = NULL;

HANDLE g_hWindowList = NULL; // I usually like to rewrite these things, but there's no point in this case.

HCURSOR g_hHandCursor = NULL; // filled later

bool g_fNoProcessing = false; // tells the status change proc not to do anything at all


PLUGININFO pluginInfo={
	sizeof(PLUGININFO),
	"Away System Modification",
	PLUGIN_MAKE_VERSION(0,3,4,0),
	"An Away System Modification for Miranda",
	"XF007",
	"corentincj@wanadoo.fr",
	" 2004-2003",
	"http://xf.zordania.com",
	0,		//not transient
	DEFMOD_SRAWAY		// mwawawawa.
};



BOOL WINAPI DllMain(HINSTANCE hinstDLL,DWORD fdwReason,LPVOID lpvReserved)
{
	g_hInstance = hinstDLL;
	return(true);
}



extern "C" __declspec(dllexport) PLUGININFO* MirandaPluginInfo(DWORD mirandaVersion)
{
	return(&pluginInfo);
}



static LRESULT CALLBACK MsgEditSubclassProc(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	switch(msg)
	{
		case WM_CHAR:
		{
			if ((wParam == '\n') && (GetKeyState(VK_CONTROL) & 0x8000))
			{
				PostMessage(GetParent(hWnd),WM_COMMAND,IDOK,0);
				return(0);
			}
		} break;
	}
	return(CallWindowProc(g_OrigEditMsgProc,hWnd,msg,wParam,lParam));
}



static int CALLBACK CompareContactsCallback(LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort)
{
	return(CallService(MS_CLIST_CONTACTSCOMPARE,lParam1,lParam2));
}



static INT_PTR CALLBACK SetAwayMsgDlgProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	static SetAwayMsgData *dat;

	switch(uMsg)
	{
		case WM_INITDIALOG:
		{
			TranslateDialogDefault(hwndDlg);

			g_hWndAwayDlg = hwndDlg;

			HWND hComboBox = GetDlgItem(hwndDlg,IDC_SAWAYMSG_MSGNAME);

			Check_Settings(); // make sure we have valid settings

			// set an icon
			HICON hTitleIcon = LoadSkinnedIcon(SKINICON_OTHER_MIRANDA);
			SendMessage(hwndDlg,WM_SETICON,ICON_BIG,(LPARAM)hTitleIcon);
			SendMessage(hwndDlg,WM_SETICON,ICON_SMALL,(LPARAM)hTitleIcon);

			dat = (SetAwayMsgData*)lParam;

//			dat = new SetAwayMsgData;
//			dat->statusMode = lParam;
			SendDlgItemMessage(hwndDlg,IDC_SAWAYMSG_MSGDATA,EM_LIMITTEXT,AWAY_PRED_DATA_MAX,0);
			SendMessage(hComboBox,CB_LIMITTEXT,AWAY_PRED_NAME_MAX,0);
			
			GetDlgItemText(hwndDlg,IDOK,dat->okButtonFormat,sizeof(dat->okButtonFormat));

			DBVARIANT dbVar;
			ENUMMSGS_DATA *enumData = new ENUMMSGS_DATA;
			if (enumData == NULL)
			{
				MessageBox(hwndDlg,Translate("An error has occured while trying to acquire messages"),Translate("Away System"),MB_ICONWARNING);
				return(false);
			}

			enumData->hComboBox = hComboBox;
			enumData->iDefMsg = 0;


			// let's get everything from the database, we'll pass the combobox's handle
			DBCONTACTENUMSETTINGS dbEnum;
			dbEnum.lParam = (LPARAM)enumData;
			dbEnum.ofsSettings = 0;
			dbEnum.pfnEnumProc = EnumMsgs;
			dbEnum.szModule = MOD_NAME;
			CallService(MS_DB_CONTACT_ENUMSETTINGS,NULL,(LPARAM)&dbEnum);

			if(DBGetContactSettingByte(NULL,MOD_NAME,"showrmsg",1))
			{
				//Ad "-- Recent --" string
				SendMessage(enumData->hComboBox,CB_ADDSTRING,0,(LPARAM)Translate(SETAWAYDLG_SHOWRMSG));
	
				/*DBCONTACTENUMSETTINGS dbEnum;
				dbEnum.lParam = (LPARAM)enumData;
				dbEnum.ofsSettings = 0;*/
				dbEnum.pfnEnumProc = EnumLastMsgs;
				//dbEnum.szModule = MOD_NAME;
				CallService(MS_DB_CONTACT_ENUMSETTINGS,NULL,(LPARAM)&dbEnum);
			}

			delete enumData;

			// now some more checking is needed for default msg/last msg
			SendMessage(hwndDlg,WM_USER+33,(dat->hInitContact == NULL) ? (0) : (2),(LPARAM)dat->hInitContact);
			if (dat->hInitContact != NULL) // if we just did a contact, we will need to write down rmsg for the main contact so we can use it later
			{
				DBVARIANT dbVar;
				int iRes;

				if (DBGetContactSettingByte(NULL,MOD_NAME,"lmestat",0)) // of we want individ
					iRes = DBGetContactSetting(NULL,MOD_NAME,StatusModeToDbSetting(dat->statusMode,"lmsg"),&dbVar);
				else
					iRes = DBGetContactSetting(NULL,MOD_NAME,"lmsg",&dbVar);

				if (iRes == 0) // ours alright!
				{
			//		strcpy(szSLastMsg,dbVar.pszVal);
					DBWriteContactSettingString(NULL,MOD_NAME,"rmsg",dbVar.pszVal);
					DBFreeVariant(&dbVar);
				}
			}
			
			if ((dat->hInitContact != NULL) || (DBGetContactSettingByte(NULL,MOD_NAME,"slastcnt",0))) // if it's set, or if init contact isn't NULL (means we just want to edit one person)
			{
				// ok now let's also set temp rmsg & stuff for contacts that have last msg
				HANDLE hContact = (HANDLE)CallService(MS_DB_CONTACT_FINDFIRST,0,0);
				WORD wSelect = SendDlgItemMessage(hwndDlg,IDC_SAWAYMSG_MSGNAME,CB_GETCOUNT,0,0)-1;
				byte fUseLMEStat = DBGetContactSettingByte(NULL,MOD_NAME,"lmestat",0) == 1;
				int iRes;
				while (hContact != NULL)
				{
					if (fUseLMEStat) // of we want individ
						iRes = DBGetContactSetting(hContact,MOD_NAME,StatusModeToDbSetting(dat->statusMode,"lmsg"),&dbVar);
					else
						iRes = DBGetContactSetting(hContact,MOD_NAME,"lmsg",&dbVar);

					if ((iRes == 0) && (dbVar.type == DBVT_ASCIIZ)) // goodie
					{
						DBWriteContactSettingString(hContact,MOD_NAME,"rmsg",dbVar.pszVal);
						DBWriteContactSettingWord(hContact,MOD_NAME,"rsel",wSelect);
					}

					DBFreeVariant(&dbVar);

					hContact = (HANDLE)CallService(MS_DB_CONTACT_FINDNEXT,(WPARAM)hContact,0);
				}
			}

			dat->countdown = DBGetContactSettingWord(NULL,MOD_NAME,"clsdelay",0);

			if (dat->countdown == 0) // we got no delay
				SetDlgItemText(hwndDlg,IDOK,Translate("OK"));
			else
			{
				SendMessage(hwndDlg,WM_TIMER,0,0);
				SetTimer(hwndDlg,1,1000,0);
			}

			if (DBGetContactSettingByte(NULL,MOD_NAME,"sdlgpos",0) == 1) // [try] getting dialog position
			{
				if (DBGetContactSettingDword(NULL,MOD_NAME,"dlgposx",-1) != -1)
				{
					LONG lX = (LONG)DBGetContactSettingDword(NULL,MOD_NAME,"dlgposx",0);

					if (DBGetContactSettingDword(NULL,MOD_NAME,"dlgposy",-1) != -1)
					{
						LONG lY = (LONG)DBGetContactSettingDword(NULL,MOD_NAME,"dlgposy",0);

						// we got both
						SetWindowPos(hwndDlg,NULL,lX,lY,0,0,SWP_NOZORDER | SWP_NOSIZE);
					}
				}
			}

			// setup the size
			RECT rcWnd, rcTree, rcButton;
			GetWindowRect(hwndDlg,&rcWnd);
			GetWindowRect(GetDlgItem(hwndDlg,IDC_SAWAYMSG_CONTACTSTREE),&rcTree);
			GetWindowRect(GetDlgItem(hwndDlg,IDC_SAWAYMSG_SHOWCONTACTS),&rcButton);

			dat->s_iShortW = (unsigned short)(rcTree.left - rcWnd.left);
			dat->s_iFullW = (unsigned short)(rcWnd.right - rcWnd.left);
			dat->s_iShortH = (unsigned short)(rcButton.bottom - rcWnd.top + 5);
			dat->s_iFullH = (unsigned short)(rcWnd.bottom - rcWnd.top);
			dat->fFullSize = false;
			SetWindowPos(hwndDlg,NULL,0,0,dat->s_iShortW,dat->s_iShortH,SWP_NOZORDER | SWP_NOMOVE);

			// ok now let's also setup the drawing font
			HFONT hFont = (HFONT)SendMessage(GetDlgItem(hwndDlg,IDC_SAWAYMSG_STATIC_VARS),WM_GETFONT,0,0); // try getting the font used by the control

			if (hFont == NULL) // if none...
			{
				hFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT); // get the default font used by the GUI
			}

			dat->hDrawFont = NULL;
			LOGFONT logFont; // font information
			GetObject(hFont,sizeof(logFont),&logFont); // get font information
			logFont.lfUnderline = true; // underline it
			dat->hDrawFont = CreateFontIndirect(&logFont); // recreate the font, underlined

			SendDlgItemMessage(hwndDlg,IDC_SAWAYMSG_STATIC_VARS,WM_SETFONT,(WPARAM)dat->hDrawFont,true);
			SendDlgItemMessage(hwndDlg,IDC_SAWAYMSG_STATIC_RESETCHNG,WM_SETFONT,(WPARAM)dat->hDrawFont,true);

			HWND hTreeView = GetDlgItem(hwndDlg,IDC_SAWAYMSG_CONTACTSTREE);
			TreeView_SetImageList(hTreeView,CallService(MS_CLIST_GETICONSIMAGELIST,0,0),TVSIL_NORMAL);

			// now for the treeview control
			TVINSERTSTRUCT tvIn;
		//	TVITEM tvItem;

			tvIn.item.mask = TVIF_TEXT | TVIF_STATE;
			tvIn.item.pszText = Translate("** All contacts **");
			tvIn.item.state = tvIn.item.stateMask = TVIS_BOLD;
			tvIn.hParent = TVI_ROOT;
			tvIn.hInsertAfter = TVI_ROOT;

			TreeView_InsertItem(hTreeView,&tvIn);

			// ok now groups
			tvIn.item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_STATE | TVIF_PARAM;
			tvIn.item.iImage = tvIn.item.iSelectedImage = IMAGE_GROUPOPEN;
			tvIn.item.state = tvIn.item.stateMask = TVIS_EXPANDED | TVIS_BOLD;
			tvIn.item.lParam = 0;
			tvIn.hParent = TVI_ROOT;
			tvIn.hInsertAfter = TVI_LAST;

//			bool fUseGrps = DBGetContactSettingByte(NULL,"CList","UseGroups",1) == 1;
//			if (fUseGrps)
//			{
				char szTemp[4];
				for (unsigned short index=0;index < 999;index++) // guess 999 groups is the max... who the hell will even use 999 groups?? :P
				{
					wsprintf(szTemp,"%d",index);
					if (DBGetContactSetting(NULL,"CListGroups",szTemp,&dbVar)) break; // we're done
					tvIn.item.pszText = dbVar.pszVal + 1; // this is shitty. (the +1 is not my idea, dunno y it's required, don't care either :))
					TreeView_InsertItem(hTreeView,&tvIn);
					DBFreeVariant(&dbVar);
				}
//			}

			// add one more
			tvIn.item.pszText = Translate("(Ungrouped)");
			HTREEITEM hDefGrp = TreeView_InsertItem(hTreeView,&tvIn);

			tvIn.item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
			tvIn.hInsertAfter = TVI_LAST;

			HTREEITEM hToSelectItem = TreeView_GetRoot(hTreeView); // the item that we're gonna select (initially)
			// ok now contacts
			// contacts: lParam = (some_handle_to_contact)
			HANDLE hContact = (HANDLE)CallService(MS_DB_CONTACT_FINDFIRST,0,0);
			while (hContact != NULL)
			{
				if (!DBGetContactSettingByte(hContact,"CList","Hidden",0)) // not hidden
				{
					tvIn.hParent = hDefGrp; // by default
					// ok, let's find if there's a group
					// if not - yay
					// if yes - damn :/

//					if (fUseGrps)
//					{
						if (DBGetContactSetting(hContact,"CList","Group",&dbVar) == 0) // argg
						{
							TVITEM tvItem;
							// it can't be the root ("** all contacts **"), find the next one
							tvItem.hItem = TreeView_GetNextSibling(hTreeView,TreeView_GetRoot(hTreeView)); // first group (if at all)

							char szGrp[128]; // group name
							while (tvItem.hItem != NULL)
							{
								tvItem.mask = TVIF_TEXT | TVIF_HANDLE;
								tvItem.pszText = szGrp;
								tvItem.cchTextMax = sizeof(szGrp);
								TreeView_GetItem(hTreeView,&tvItem);

								if (lstrcmp(szGrp,dbVar.pszVal) == 0) // we got it
								{
									tvIn.hParent = tvItem.hItem;
									break;
								}

								tvItem.hItem = TreeView_GetNextSibling(hTreeView,tvItem.hItem); // first group (if at all)
							}
							DBFreeVariant(&dbVar);
						}
//					}

					// ok let's finish setting up the item
					tvIn.item.pszText = (char*)CallService(MS_CLIST_GETCONTACTDISPLAYNAME,(WPARAM)hContact,0); // text
					tvIn.item.iImage = tvIn.item.iSelectedImage = CallService(MS_CLIST_GETCONTACTICON,(WPARAM)hContact,0);
					tvIn.item.lParam = (long)hContact;

					HTREEITEM hNewItem = TreeView_InsertItem(hTreeView,&tvIn);

					if ((tvIn.item.lParam != NULL) && ((HANDLE)tvIn.item.lParam == dat->hInitContact)) // init contact
					{
						hToSelectItem = hNewItem;
					}
				}
				hContact = (HANDLE)CallService(MS_DB_CONTACT_FINDNEXT,(WPARAM)hContact,0);
			}

			// let's remove empty groups
			HTREEITEM hItem = TreeView_GetNextSibling(hTreeView,TreeView_GetRoot(hTreeView));
			while (hItem != NULL)
			{
				HTREEITEM hNextItem = TreeView_GetNextSibling(hTreeView,hItem);
				if (TreeView_GetChild(hTreeView,hItem) == NULL) // no children
				{
					TreeView_DeleteItem(hTreeView,hItem);
				}
				hItem = hNextItem;
			}

			// sort the list
			TVSORTCB tvSort;
			tvSort.hParent = TreeView_GetNextSibling(hTreeView,TreeView_GetRoot(hTreeView));
			tvSort.lParam = 9; // moshe (egg!)
			tvSort.lpfnCompare = CompareContactsCallback;

			while (tvSort.hParent != NULL)
			{
				TreeView_SortChildrenCB(hTreeView,&tvSort,0);
				tvSort.hParent = TreeView_GetNextSibling(hTreeView,tvSort.hParent);
			}

			// select the first item
			TreeView_SetIndent(hTreeView,38);

			TreeView_SelectItem(hTreeView,hToSelectItem);

			// ok let's setup the hook
			dat->hContactHook = HookEventMessage(ME_CLIST_CONTACTICONCHANGED,hwndDlg,WM_USER+30);
//			dat->hLastContact = NULL; // last contact used (NULL is the general contact)

			// let's set the new title
			char str[256];
			GetWindowText(hwndDlg,dat->titleFormat,sizeof(dat->titleFormat));
			if (dat->hInitContact == NULL) // this is the root
			{
				_snprintf(str,sizeof(str),dat->titleFormat,(char*)CallService(MS_CLIST_GETSTATUSMODEDESCRIPTION,dat->statusMode,0),Translate("All Contacts"));
			}
			else // a single item
			{
				_snprintf(str,sizeof(str),dat->titleFormat,(char*)CallService(MS_CLIST_GETSTATUSMODEDESCRIPTION,dat->statusMode,0),CallService(MS_CLIST_GETCONTACTDISPLAYNAME,(WPARAM)dat->hInitContact,0));
			}
			SetWindowText(hwndDlg,str);

			g_OrigEditMsgProc = (WNDPROC)SetWindowLongPtr(GetDlgItem(hwndDlg,IDC_SAWAYMSG_MSGDATA),GWLP_WNDPROC,(LONG_PTR)MsgEditSubclassProc);
			return(1);
		} break;
		case WM_USER + 18:
		{
			KillTimer(hwndDlg,1);
			HWND hTreeView = GetDlgItem(hwndDlg,IDC_SAWAYMSG_CONTACTSTREE);

			TVITEM tvItem;
			tvItem.mask = TVIF_HANDLE | TVIF_PARAM;
			tvItem.hItem = TreeView_GetSelection(hTreeView);
			TreeView_GetItem(hTreeView,&tvItem);

			if ((tvItem.lParam == 0) && (tvItem.hItem != TreeView_GetRoot(hTreeView)))
			{
				SetDlgItemText(hwndDlg,IDOK,Translate("Apply"));
			}
			else
			{
				SetDlgItemText(hwndDlg,IDOK,Translate("OK"));
			}
			return(true);
		} break;
		case WM_USER + 30: // the icon for a contact has changed
		{
			HWND hTreeView = GetDlgItem(hwndDlg,IDC_SAWAYMSG_CONTACTSTREE);
			TVITEM tvItem;
			tvItem.mask = TVIF_PARAM | TVIF_HANDLE;
			// go through all the list and find the item
			tvItem.hItem = TreeView_GetRoot(hTreeView);

			// it can't be the root ("** all contacts **"), find the next one
			tvItem.hItem = TreeView_GetChild(hTreeView,TreeView_GetNextSibling(hTreeView,tvItem.hItem));
			while (tvItem.hItem != NULL)
			{
				TreeView_GetItem(hTreeView,&tvItem);

				if ((HANDLE)tvItem.lParam == (HANDLE)wParam) // finally
				{
					tvItem.mask = TVIF_HANDLE | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
					tvItem.iImage = tvItem.iSelectedImage = lParam;
					TreeView_SetItem(hTreeView,&tvItem);
					break;
				}

				// try to find a child
				HTREEITEM hChild = TreeView_GetChild(hTreeView,tvItem.hItem);
				if (hChild != NULL)
				{
					tvItem.hItem = hChild;
				}
				else
				{
					// try find a next item
					HTREEITEM hNextSib = TreeView_GetNextSibling(hTreeView,tvItem.hItem); // first group (if at all)

					if (hNextSib != NULL) // great
					{
						tvItem.hItem = hNextSib;
					}
					else // last attempt
					{
						// find the parent's next sibling
						tvItem.hItem = TreeView_GetChild(hTreeView,TreeView_GetNextSibling(hTreeView,TreeView_GetParent(hTreeView,tvItem.hItem)));
					}
				}
			}

			if (tvItem.hItem != NULL) // means we found our item
			{
				// sort
				TVSORTCB tvSort;
				tvSort.hParent = TreeView_GetParent(hTreeView,tvItem.hItem);
				tvSort.lParam = 9; // moshe (egg!)
				tvSort.lpfnCompare = CompareContactsCallback;

				TreeView_SortChildrenCB(hTreeView,&tvSort,0);
			}
			
			SetWindowLongPtr(hwndDlg,DWL_MSGRESULT,0);
			return(0);
		} break;
		case WM_NOTIFY: // Notification message...
		{
			switch(((NMHDR*)lParam)->code) // check the notification code
			{
				case NM_CLICK:
				case NM_RCLICK: // post r-click/d-click era - select using right click too
				{
					HWND hTreeView = GetDlgItem(hwndDlg,IDC_SAWAYMSG_CONTACTSTREE);

					TVHITTESTINFO hitTest;
					RECT rcWnd;
					GetCursorPos(&hitTest.pt);
					GetWindowRect(hTreeView,&rcWnd);
					hitTest.pt.x -= rcWnd.left;
					hitTest.pt.y -= rcWnd.top;

					TreeView_HitTest(hTreeView,&hitTest);

					if (hitTest.hItem != NULL)
					{
						switch(((NMHDR*)lParam)->code)
						{
							case NM_CLICK:
							{
								if (TreeView_GetRoot(hTreeView) != hitTest.hItem)
								{
									// let's make sure this isn't a group
									TVITEM tvItem;
									tvItem.mask = TVIF_PARAM | TVIF_HANDLE;
									tvItem.hItem = hitTest.hItem;
									TreeView_GetItem(hTreeView,&tvItem);

									TreeView_SelectItem(hTreeView,tvItem.hItem); // select it

									if ((hitTest.flags & TVHT_ONITEMICON) && (tvItem.lParam == 0))
									{
										tvItem.mask = TVIF_HANDLE | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
										tvItem.hItem = hitTest.hItem;
										TreeView_GetItem(hTreeView,&tvItem);
										tvItem.iImage = tvItem.iSelectedImage = 23 - tvItem.iImage; // switch between 11 and 12
										TreeView_SetItem(hTreeView,&tvItem);

										TreeView_Expand(hTreeView,hitTest.hItem,TVE_TOGGLE);
									}
								}
							} break;
							case NM_RCLICK:
							{
								// let's make sure this isn't a group
								TVITEM tvItem;
								tvItem.mask = TVIF_PARAM | TVIF_HANDLE;
								tvItem.hItem = hitTest.hItem;
								TreeView_GetItem(hTreeView,&tvItem);

								TreeView_SelectItem(hTreeView,tvItem.hItem); // select it
							} break;
						}
					}
				} break;
				case TVN_ITEMEXPANDING: // we don't *really* care, we just want to set the right image
				{
					NMTREEVIEW *nmTV = (NMTREEVIEW*)lParam;
					
					TVITEM tvItem;
					tvItem.mask = TVIF_HANDLE | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
					tvItem.hItem = nmTV->itemNew.hItem;
					TreeView_GetItem(GetDlgItem(hwndDlg,IDC_SAWAYMSG_CONTACTSTREE),&tvItem);
					tvItem.iImage = tvItem.iSelectedImage = 23 - tvItem.iImage;
					TreeView_SetItem(GetDlgItem(hwndDlg,IDC_SAWAYMSG_CONTACTSTREE),&tvItem);
				} break;
				case NM_CUSTOMDRAW:
				{
					NMTVCUSTOMDRAW *lpNMCD = (NMTVCUSTOMDRAW*)lParam;

					if (lpNMCD->nmcd.hdr.hwndFrom == GetDlgItem(hwndDlg,IDC_SAWAYMSG_CONTACTSTREE))
					{
						switch(lpNMCD->nmcd.dwDrawStage) // what is this stage?
						{
							case CDDS_PREPAINT: // the control is about to start painting
							{
								SetWindowLongPtr(hwndDlg,DWL_MSGRESULT,CDRF_NOTIFYITEMDRAW); // instruct the control to return information when it draws items
								return(true);
							} break;
							case CDDS_ITEMPREPAINT: // we want do draw an item
							{
								if (lpNMCD->nmcd.lItemlParam == 0)
								{
									return(true);
								}

								RECT rcRect; // rect for item
								TreeView_GetItemRect(lpNMCD->nmcd.hdr.hwndFrom,(HTREEITEM)lpNMCD->nmcd.dwItemSpec,&rcRect,true);
								int iSize = TreeView_GetItemHeight(lpNMCD->nmcd.hdr.hwndFrom);
								
								HICON hIcon = NULL;
								DBVARIANT dbVar;
								if (DBGetContactSettingByte((HANDLE)lpNMCD->nmcd.lItemlParam,MOD_NAME,"ignorereq",0))
								{
									hIcon = LoadSkinnedIcon(SKINICON_OTHER_USERONLINE);
								}
								else
								{
									int x = rcRect.left - iSize*2 - 5;
									if (DBGetContactSetting((HANDLE)lpNMCD->nmcd.lItemlParam,MOD_NAME,"rmsg",&dbVar) == 0)
									{
										hIcon = LoadIcon(g_hInstance,MAKEINTRESOURCE(IDI_MSGICON));;
										x -= iSize + 2;
										DBFreeVariant(&dbVar);
									}
									// here let's draw the sendmsg
									if (DBGetContactSettingByte((HANDLE)lpNMCD->nmcd.lItemlParam,MOD_NAME,"sendmsg",0))
									{
										DrawIconEx(lpNMCD->nmcd.hdc,x,rcRect.top,LoadSkinnedIcon(SKINICON_EVENT_MESSAGE),iSize,iSize,0,NULL,DI_NORMAL);
									}
								}
								if (hIcon != NULL)
								{
									DrawIconEx(lpNMCD->nmcd.hdc,rcRect.left-iSize*2-5,rcRect.top,hIcon,iSize,iSize,0,NULL,DI_NORMAL);
								}								
							} break;
						}
					}
				} break;
				case TVN_SELCHANGING:
				{
					NMTREEVIEW *nmTV = (NMTREEVIEW*)lParam;
					HWND hTreeView = nmTV->hdr.hwndFrom;

					if (g_OrigEditMsgProc == NULL) // means we're not working yet
					{
						return(true);
					}

					if ((nmTV->itemOld.lParam != 0) || (nmTV->itemOld.hItem == TreeView_GetRoot(hTreeView))) // a single item or the root
					{
						if (SendDlgItemMessage(hwndDlg,IDC_SAWAYMSG_MSGNAME,CB_GETCURSEL,0,0) >= 0)
						{
							DBWriteContactSettingWord((HANDLE)nmTV->itemOld.lParam,MOD_NAME,"rsel",(WORD)SendDlgItemMessage(hwndDlg,IDC_SAWAYMSG_MSGNAME,CB_GETCURSEL,0,0));
						}
						else
						{
							DBDeleteContactSetting((HANDLE)nmTV->itemOld.lParam,MOD_NAME,"rsel");
						}
						
						char str[AWAY_PRED_DATA_MAX+1];
						GetDlgItemText(hwndDlg,IDC_SAWAYMSG_MSGDATA,str,sizeof(str));

						if (lstrlen(str) > 0) // we got something
						{
							DBWriteContactSettingString((HANDLE)nmTV->itemOld.lParam,MOD_NAME,"rmsg",str);
						}
						else
						{
							DBDeleteContactSetting((HANDLE)nmTV->itemOld.lParam,MOD_NAME,"rmsg"); // delete what we got
						}

						if (nmTV->itemOld.lParam != 0) // this isn't root (we write ignorereq)
						{
							DBWriteContactSettingByte((HANDLE)nmTV->itemOld.lParam,MOD_NAME,"ignorereq",(IsDlgButtonChecked(hwndDlg,IDC_SAWAYMSG_IGNOREREQ) == BST_CHECKED) ? (1) : (0));
						}
						
						// write sendmsg
						if (IsWindowEnabled(GetDlgItem(hwndDlg,IDC_SAWAYMSG_SENDMSG)))
						{
							DBWriteContactSettingByte((HANDLE)nmTV->itemOld.lParam,MOD_NAME,"sendmsg",(IsDlgButtonChecked(hwndDlg,IDC_SAWAYMSG_SENDMSG) == BST_CHECKED) ? (1) : (0));
							if(nmTV->itemOld.lParam == NULL)
							{
								UpdateSOEButtons((IsDlgButtonChecked(hwndDlg,IDC_SAWAYMSG_SENDMSG) == BST_CHECKED) ? (1) : (0));
							}
						}
						else
						{
							DBDeleteContactSetting((HANDLE)nmTV->itemOld.lParam,MOD_NAME,"sendmsg");
							if(nmTV->itemOld.lParam == NULL)
							{
								UpdateSOEButtons(0);
							}
						}
/*						InvalidateRect(hTreeView,NULL,true);
						UpdateWindow(hTreeView);*/
					}

					// let's set the new title
					char str[256];
					if (nmTV->itemNew.hItem == TreeView_GetRoot(hTreeView)) // this is the root
					{
						_snprintf(str,sizeof(str),dat->titleFormat,(char*)CallService(MS_CLIST_GETSTATUSMODEDESCRIPTION,dat->statusMode,0),Translate("All Contacts"));
					}
					else // something else
					{
						TVITEM tvItem;
						char pszText[128];
						tvItem.mask = TVIF_HANDLE | TVIF_TEXT;
						tvItem.hItem = nmTV->itemNew.hItem;
						tvItem.pszText = pszText;
						tvItem.cchTextMax = 128;
						TreeView_GetItem(hTreeView,&tvItem);
						
						_snprintf(str,sizeof(str),dat->titleFormat,(char*)CallService(MS_CLIST_GETSTATUSMODEDESCRIPTION,dat->statusMode,0),tvItem.pszText);
						if (nmTV->itemNew.lParam == 0) // category
						{
							strcat(str," ");
							strcat(str,Translate("(group)"));
						}
					}
					SetWindowText(hwndDlg,str);

					HTREEITEM hTT = TreeView_GetRoot(hTreeView);

					if ((((nmTV->itemOld.hItem == TreeView_GetRoot(hTreeView)) ? (0) : ((nmTV->itemOld.lParam == 0)) ? (1) : (2))) != 1)
					{
						DBVARIANT dbVar;
						// see if we had a last  item
						byte fUseLMEStat = DBGetContactSettingByte(NULL,MOD_NAME,"lmestat",0) == 1;

						int iRes;
						if (fUseLMEStat) // of we want individ
							iRes = DBGetContactSetting((HANDLE)nmTV->itemOld.lParam,MOD_NAME,StatusModeToDbSetting(dat->statusMode,"lmsg"),&dbVar);
						else
							iRes = DBGetContactSetting((HANDLE)nmTV->itemOld.lParam,MOD_NAME,"lmsg",&dbVar);

						if (iRes == 0) // ours alright!
						{
							// IMPORTANT: before we call to setup the msg box & combobox, we need to delete the last item in the combobox -> that's a must!!
							char *lpszData = (char*)SendDlgItemMessage(hwndDlg,IDC_SAWAYMSG_MSGNAME,CB_GETITEMDATA,SendDlgItemMessage(hwndDlg,IDC_SAWAYMSG_MSGNAME,CB_GETCOUNT,0,0)-1,0);
							if (lpszData != NULL) // no (), just to be sure
							{
								delete [] lpszData; // deallocate!
							}
							SendDlgItemMessage(hwndDlg,IDC_SAWAYMSG_MSGNAME,CB_DELETESTRING,SendDlgItemMessage(hwndDlg,IDC_SAWAYMSG_MSGNAME,CB_GETCOUNT,0,0)-1,0);
							DBFreeVariant(&dbVar);

							if (SendDlgItemMessage(hwndDlg,IDC_SAWAYMSG_MSGNAME,CB_GETCOUNT,0,0) == 0)
							{
								SendDlgItemMessage(hwndDlg,IDC_SAWAYMSG_MSGNAME,CB_SETCURSEL,-1,0);
							}
						}
					}

					SendMessage(hwndDlg,WM_USER+33,((nmTV->itemNew.hItem == TreeView_GetRoot(hTreeView)) ? (0) : ((nmTV->itemNew.lParam == 0)) ? (1) : (2)),(LPARAM)nmTV->itemNew.lParam);
				} break;
				default:break;
			}
			return(true);
		} break;
		case WM_USER + 33:
		{
			// lParam is the contact
			// wParam - 0 - all contacts - 1 - category - 2 - single
			HANDLE hContact = (HANDLE)lParam;
			HWND hComboBox = GetDlgItem(hwndDlg,IDC_SAWAYMSG_MSGNAME);
			char szSLastMsg[AWAY_PRED_DATA_MAX+1];
			szSLastMsg[0] = '\0';

			EnableWindow(GetDlgItem(hwndDlg,IDC_SAWAYMSG_MSGNAME),true); // enable first (might be disabled when we're done)

			byte fUseLMEStat;
			DBVARIANT dbVar;
			if (wParam != 1) // not a category
			{
				int iRes;
				fUseLMEStat = DBGetContactSettingByte(NULL,MOD_NAME,"lmestat",0) == 1;

				if (fUseLMEStat) // of we want individ
					iRes = DBGetContactSetting(hContact,MOD_NAME,StatusModeToDbSetting(dat->statusMode,"lmsg"),&dbVar);
				else
					iRes = DBGetContactSetting(hContact,MOD_NAME,"lmsg",&dbVar);

				if (iRes == 0) // ours alright!
				{
					strcpy(szSLastMsg,dbVar.pszVal);
					DBFreeVariant(&dbVar);
				}
			}


			SetDlgItemText(hwndDlg,IDOK,Translate("OK"));
			if (strlen(szSLastMsg) > 0)
			{
				// let's also add it to the blabla
				// no annoying line

				char *szData;
				szData = new char[strlen(szSLastMsg)+1];
				strcpy(szData,szSLastMsg);

				char szTempTitle[128];

				// 2 different titles for last msg
				if (fUseLMEStat)
				{
					char szTemppy[128];
					strcpy(szTemppy," ");
					strcat(szTemppy,(char*)CallService(MS_CLIST_GETSTATUSMODEDESCRIPTION,dat->statusMode,0));
					strcat(szTemppy," ");
					// now copy over
					sprintf(szTempTitle,Translate(SETAWAYDLG_LASTMSGTITLE),szTemppy);
				}
				else
				{
					sprintf(szTempTitle,Translate(SETAWAYDLG_LASTMSGTITLE)," ");
				}
				int iID = SendMessage(hComboBox,CB_ADDSTRING,0,(LPARAM)szTempTitle);
				SendMessage(hComboBox,CB_SETITEMDATA,iID,(LPARAM)szData);
				SendMessage(hComboBox,CB_SETCURSEL,iID,0);
			}

			if ((wParam == 2) && (DBGetContactSetting(hContact,MOD_NAME,"rmsg",&dbVar) == 0)) // normal item
			{
				// ok so let's use the last (we don't setup the default or smt!)
				if (DBGetContactSetting(hContact,MOD_NAME,"rmsg",&dbVar) == 0)
				{
					SetWindowText(GetDlgItem(hwndDlg,IDC_SAWAYMSG_MSGDATA),dbVar.pszVal);
				}
				else
				{
					SetWindowText(GetDlgItem(hwndDlg,IDC_SAWAYMSG_MSGDATA),"");
				}
				DBFreeVariant(&dbVar);
				SendMessage(hComboBox,CB_SETCURSEL,DBGetContactSettingWord(hContact,MOD_NAME,"rsel",0),0);
			}
			else if (wParam != 0) // an item (category or single) with nothing set before
			{
				if (strlen(szSLastMsg) == 0) // no last msg
				{
					SendMessage(hComboBox,CB_SETCURSEL,-1,0);
					SetWindowText(GetDlgItem(hwndDlg,IDC_SAWAYMSG_MSGDATA),"");
				}
				else
				{
					SetDlgItemText(hwndDlg,IDC_SAWAYMSG_MSGDATA,szSLastMsg);
				}

				if (wParam == 1) // category
				{
					SetDlgItemText(hwndDlg,IDOK,Translate("Apply"));
				}
			}
			else // some item (root)
			{
				char szSMsg[AWAY_PRED_DATA_MAX+1];
				char szSTitle[AWAY_PRED_NAME_MAX+1];
				szSTitle[0] = '\0';
				szSMsg[0] = '\0';

				if (DBGetContactSetting(NULL,MOD_NAME,"rmsg",&dbVar) == 0)
				{
					strcpy(szSMsg,dbVar.pszVal);
					DBFreeVariant(&dbVar);
				}
				else if (DBGetContactSettingByte(NULL,MOD_NAME,"usedef",0) == 0)
				{
					if (strlen(szSLastMsg) > 0) // got last msg
						strcpy(szSMsg,szSLastMsg);
					else // default
						Get_Default_Message(szSTitle,szSMsg);
					DBFreeVariant(&dbVar);
				}
				else// if ((hContact == NULL) && (wParam == 0)) // get default (only if this is the main contact)
				{
					Get_Default_Message(szSTitle,szSMsg);
				}

				// now, apply it
				if (lstrlen(szSMsg) > 0)
				{
					SetDlgItemText(hwndDlg,IDC_SAWAYMSG_MSGDATA,szSMsg); // we set the title anyway even though Windows will probably do it for us with CB_SETCURSEL (not sure) -> but let's set it anyway, no harm
				}
				else
				{
					SetDlgItemText(hwndDlg,IDC_SAWAYMSG_MSGDATA,""); // we set the title anyway even though Windows will probably do it for us with CB_SETCURSEL (not sure) -> but let's set it anyway, no harm
				}

				if (strlen(szSTitle) > 0) // default -> find the title
				{
					int iSearch = SendMessage(hComboBox,CB_FINDSTRINGEXACT,-1,(LPARAM)szSTitle);
					if (iSearch != CB_ERR) // found something! =)
						SendMessage(hComboBox,CB_SETCURSEL,iSearch,0);
				//	else
				//		SendMessage(hComboBox,CB_SETCURSEL,0,0);
				}
			}
			SendMessage(hwndDlg,WM_USER+35,0,0); // changes were made

			// while we're at it, let's also set settings like sendmsg & ignorereq
			if ((hContact == NULL) && (wParam == 0)) // main contact
			{
				EnableWindow(GetDlgItem(hwndDlg,IDC_SAWAYMSG_IGNOREREQ),false);
				CheckDlgButton(hwndDlg,IDC_SAWAYMSG_IGNOREREQ,BST_UNCHECKED);
				CheckDlgButton(hwndDlg,IDC_SAWAYMSG_SENDMSG,(DBGetContactSettingByte(hContact,MOD_NAME,"sendmsg",0) == 1) ? (BST_CHECKED) : (BST_UNCHECKED));
			}
			else if (wParam == 1) // category
			{
				EnableWindow(GetDlgItem(hwndDlg,IDC_SAWAYMSG_SENDMSG),true);
				EnableWindow(GetDlgItem(hwndDlg,IDC_SAWAYMSG_IGNOREREQ),true);
				CheckDlgButton(hwndDlg,IDC_SAWAYMSG_SENDMSG,BST_UNCHECKED);
				CheckDlgButton(hwndDlg,IDC_SAWAYMSG_IGNOREREQ,BST_UNCHECKED);
			}
			else // item
			{
				bool fUseReq = DBGetContactSettingByte(hContact,MOD_NAME,"ignorereq",0) == 1;
				CheckDlgButton(hwndDlg,IDC_SAWAYMSG_IGNOREREQ,(fUseReq) ? (BST_CHECKED) : (BST_UNCHECKED));
				EnableWindow(GetDlgItem(hwndDlg,IDC_SAWAYMSG_IGNOREREQ),true);
				if (fUseReq)
				{
					EnableWindow(GetDlgItem(hwndDlg,IDC_SAWAYMSG_SENDMSG),false);
				}
				else
				{
					EnableWindow(GetDlgItem(hwndDlg,IDC_SAWAYMSG_SENDMSG),true);
				}
				CheckDlgButton(hwndDlg,IDC_SAWAYMSG_SENDMSG,(DBGetContactSettingByte(hContact,MOD_NAME,"sendmsg",0) == 1) ? (BST_CHECKED) : (BST_UNCHECKED));
			}

			if (SendMessage(hComboBox,CB_GETCOUNT,0,0) == 0) // no msgs, sux
			{
				EnableWindow(GetDlgItem(hwndDlg,IDC_SAWAYMSG_MSGNAME),false); // disable window
			}
		} break;
		case WM_TIMER:
		{
			if(dat->countdown == -1)
			{
				SendMessage(hwndDlg,WM_USER+60,0,0);
				return(true);
			}

			char str[64];
			_snprintf(str,sizeof(str),dat->okButtonFormat,dat->countdown);
			SetDlgItemText(hwndDlg,IDOK,str);
			dat->countdown--;
		} break;
		case WM_USER + 60:
		{
			HWND hTreeView = GetDlgItem(hwndDlg,IDC_SAWAYMSG_CONTACTSTREE);

			TVITEM tvItem;
			tvItem.mask = TVIF_HANDLE | TVIF_PARAM;
			tvItem.hItem = TreeView_GetSelection(hTreeView);
			TreeView_GetItem(hTreeView,&tvItem);

			bool fLMEStat = DBGetContactSettingByte(NULL,MOD_NAME,"lmestat",0) == 1;

			// what we do:
			// we go through each contact (except the current selected one) and save for each contact its msg (cmsg) and as last (before we analyze it) - lmsg/lmsg-stat
			HANDLE hContact = (HANDLE)CallService(MS_DB_CONTACT_FINDFIRST,0,0);
			DBVARIANT dbVar;
			while (hContact != NULL)
			{
				if (fLMEStat) // individ
					DBDeleteContactSetting(hContact,MOD_NAME,StatusModeToDbSetting(dat->statusMode,"lmsg")); // remember last msg
				else
					DBDeleteContactSetting(hContact,MOD_NAME,"lmsg"); // remember last msg

				if (fLMEStat) // individ
					DBDeleteContactSetting(hContact,MOD_NAME,StatusModeToDbSetting(dat->statusMode,"cmsg")); 
				else
					DBDeleteContactSetting(hContact,MOD_NAME,"cmsg"); 
				
				if (hContact != (HANDLE)tvItem.lParam) // except the selected one
				{
					if (DBGetContactSetting(hContact,MOD_NAME,"rmsg",&dbVar) == 0)
					{
						WriteAwayMsgInDB(hContact, dbVar.pszVal, dat->statusMode, 1111);
						
						DBFreeVariant(&dbVar);
					}
				}
				hContact = (HANDLE)CallService(MS_DB_CONTACT_FINDNEXT,(WPARAM)hContact,0);
			}

			// ok now the one we're currently working on
			if (fLMEStat) // individ
				DBDeleteContactSetting((HANDLE)tvItem.lParam,MOD_NAME,StatusModeToDbSetting(dat->statusMode,"lmsg")); // remember last msg
			else
				DBDeleteContactSetting((HANDLE)tvItem.lParam,MOD_NAME,"lmsg"); // remember last msg
			
			if (fLMEStat) // individ
				DBDeleteContactSetting((HANDLE)tvItem.lParam,MOD_NAME,StatusModeToDbSetting(dat->statusMode,"cmsg"));
			else
				DBDeleteContactSetting((HANDLE)tvItem.lParam,MOD_NAME,"cmsg");



			char str[AWAY_MSGDATA_MAX+1];
			GetDlgItemText(hwndDlg,IDC_SAWAYMSG_MSGDATA,str,sizeof(str));

			if ((tvItem.hItem == TreeView_GetRoot(hTreeView)) && (lstrlen(str) == 0)) // this is the root and we don't have a msg!
			{
				strcpy(str,Translate(AWAY_DF_MSG));
			}

			if (lstrlen(str) > 0)
			{
				WriteAwayMsgInDB((HANDLE)tvItem.lParam, str, dat->statusMode, 1111);
			}

			// write sendmsg
			if (IsWindowEnabled(GetDlgItem(hwndDlg,IDC_SAWAYMSG_SENDMSG)))
			{
				DBWriteContactSettingByte((HANDLE)tvItem.lParam,MOD_NAME,"sendmsg",(IsDlgButtonChecked(hwndDlg,IDC_SAWAYMSG_SENDMSG) == BST_CHECKED) ? (1) : (0));
				if(tvItem.lParam == NULL)
				{
					UpdateSOEButtons((IsDlgButtonChecked(hwndDlg,IDC_SAWAYMSG_SENDMSG) == BST_CHECKED) ? (1) : (0));
				}
			}
			else
			{
				DBDeleteContactSetting((HANDLE)tvItem.lParam,MOD_NAME,"sendmsg");
				if(tvItem.lParam == NULL)
				{
					UpdateSOEButtons(0);
				}
			}

			if (tvItem.lParam != 0) // this isn't root (we write ignorereq)
			{
				DBWriteContactSettingByte((HANDLE)tvItem.lParam,MOD_NAME,"ignorereq",(IsDlgButtonChecked(hwndDlg,IDC_SAWAYMSG_IGNOREREQ) == BST_CHECKED) ? (1) : (0));
			}


			if (tvItem.hItem != TreeView_GetRoot(hTreeView)) // meaning we just wrote down an ordinary message and now we need to write down from rmsg the general one
			{
				if (DBGetContactSetting(NULL,MOD_NAME,"rmsg",&dbVar) == 0)
				{
					strcpy(str,dbVar.pszVal);
					DBFreeVariant(&dbVar);
				}
				else
				{
					strcpy(str,Translate(AWAY_DF_MSG));
				}

				WriteAwayMsgInDB(NULL, str, dat->statusMode, 1111);
			}
			if (dat->szProtocol == NULL)
			{
				ChangeAllProtoMessages(dat->statusMode,str); // str will be the general message when we're done... in any case :)
			}
			else
			{
				CallProtoService(dat->szProtocol,PS_SETAWAYMSG,dat->statusMode,(LPARAM)str);
			}

//			DestroyWindow(hwndDlg);
			EndDialog(hwndDlg,2);
			return(true);
		} break;
		case WM_MOVING: // stops counting
		{
			SendMessage(hwndDlg,WM_USER+18,0,0); // reset counter
			return(true);
		} break;
		case WM_COMMAND:
		{
			switch (HIWORD(wParam))
			{
				case BN_CLICKED:
				{
					switch(LOWORD(wParam))
					{
						case IDC_SAWAYMSG_IGNOREREQ:
						{
							EnableWindow(GetDlgItem(hwndDlg,IDC_SAWAYMSG_SENDMSG),IsDlgButtonChecked(hwndDlg,IDC_SAWAYMSG_IGNOREREQ) == BST_UNCHECKED);
							SendMessage(hwndDlg,WM_USER+18,0,0); // reset counter
						} break;
						case IDC_SAWAYMSG_SENDMSG:
						{
							SendMessage(hwndDlg,WM_USER+18,0,0); // reset counter
						} break;
						case IDC_SAWAYMSG_SHOWCONTACTS:
						{
							SendMessage(hwndDlg,WM_USER+18,0,0); // reset counter
							RECT rcWnd;
							GetWindowRect(hwndDlg,&rcWnd);

							dat->fFullSize = !dat->fFullSize;
							
							if (dat->fFullSize)
							{
								SetWindowPos(hwndDlg,NULL,0,0,dat->s_iFullW,dat->s_iFullH,SWP_NOZORDER | SWP_NOMOVE);
								SetDlgItemText( hwndDlg, IDC_SAWAYMSG_SHOWCONTACTS, Translate("Reduce <<") );
								
							}
							else
							{
								SetWindowPos(hwndDlg,NULL,0,0,dat->s_iShortW,dat->s_iShortH,SWP_NOZORDER | SWP_NOMOVE);
								SetDlgItemText( hwndDlg, IDC_SAWAYMSG_SHOWCONTACTS, Translate("Expand >>") );
							}

						} break;
						case IDC_SAWAYMSG_STATIC_RESETCHNG:
						{
							HANDLE hContact = (HANDLE)CallService(MS_DB_CONTACT_FINDFIRST,0,0);
							while (hContact != NULL)
							{
								DBDeleteContactSetting(hContact,MOD_NAME,"rmsg");
								DBDeleteContactSetting(hContact,MOD_NAME,"rsel");
								DBDeleteContactSetting(hContact,MOD_NAME,"ignorereq");
								DBDeleteContactSetting(hContact,MOD_NAME,"sendmsg");
								hContact = (HANDLE)CallService(MS_DB_CONTACT_FINDNEXT,(WPARAM)hContact,0);
							}

							HWND hTreeView = GetDlgItem(hwndDlg,IDC_SAWAYMSG_CONTACTSTREE);
							if (TreeView_GetSelection(hTreeView) != TreeView_GetRoot(hTreeView)) // we're doing something other than the root
							{
								SetDlgItemText(hwndDlg,IDC_SAWAYMSG_MSGDATA,"");
								SendMessage(hwndDlg,WM_USER+35,0,0); // changes were made
								SendDlgItemMessage(hwndDlg,IDC_SAWAYMSG_MSGNAME,CB_SETCURSEL,-1,0);
							}

							InvalidateRect(GetDlgItem(hwndDlg,IDC_SAWAYMSG_CONTACTSTREE),NULL,true);
							UpdateWindow(GetDlgItem(hwndDlg,IDC_SAWAYMSG_CONTACTSTREE));
						} break;
						case IDC_SAWAYMSG_STATIC_VARS:
						{
							SendMessage(hwndDlg,WM_USER+18,0,0); // reset counter

							// show list
							CreateDialog(g_hInstance,MAKEINTRESOURCE(IDD_VARSLISTDLG),hwndDlg,VarsListDlgProc);
						} break;
						case IDOK:
						{
							char szFormat[64];
							GetDlgItemText(hwndDlg,IDOK,szFormat,sizeof(szFormat));
							if (strcmp(szFormat,Translate("Apply")) == 0) // we're not leaving yet!!
							{
								HWND hTreeView = GetDlgItem(hwndDlg,IDC_SAWAYMSG_CONTACTSTREE);
								char str[AWAY_PRED_DATA_MAX+1];
								GetDlgItemText(hwndDlg,IDC_SAWAYMSG_MSGDATA,str,sizeof(str));
								int iCBSelection = (int)SendDlgItemMessage(hwndDlg,IDC_SAWAYMSG_MSGNAME,CB_GETCURSEL,0,0);
								byte bReq = (IsDlgButtonChecked(hwndDlg,IDC_SAWAYMSG_IGNOREREQ) == BST_CHECKED) ? (1) : (0);
								byte bMsg = ((IsDlgButtonChecked(hwndDlg,IDC_SAWAYMSG_SENDMSG) == BST_CHECKED) && (!bReq)) ? (1) : (0);

								// for every child *sniff* :)

								TVITEM tvItem;
								tvItem.mask = TVIF_HANDLE | TVIF_PARAM;
								tvItem.hItem = TreeView_GetChild(hTreeView,TreeView_GetSelection(hTreeView));
								while (tvItem.hItem != NULL)
								{
									TreeView_GetItem(hTreeView,&tvItem);

									DBWriteContactSettingWord((HANDLE)tvItem.lParam,MOD_NAME,"rsel",iCBSelection);

									if (lstrlen(str) > 0)
									{
										DBWriteContactSettingString((HANDLE)tvItem.lParam,MOD_NAME,"rmsg",str);
									}
									else
									{
										DBDeleteContactSetting((HANDLE)tvItem.lParam,MOD_NAME,"rmsg"); // delete what we got
									}

									if (tvItem.lParam != 0) // this isn't root (we write ignorereq)
									{
										DBWriteContactSettingByte((HANDLE)tvItem.lParam,MOD_NAME,"ignorereq",bReq);
									}

									if (bMsg)
									{
										DBWriteContactSettingByte((HANDLE)tvItem.lParam,MOD_NAME,"sendmsg",bMsg);
										if(tvItem.lParam == NULL)
										{
											UpdateSOEButtons(bMsg);
										}
									}
									else
									{
										DBDeleteContactSetting((HANDLE)tvItem.lParam,MOD_NAME,"sendmsg");
										if(tvItem.lParam == NULL)
										{
											UpdateSOEButtons(0);
										}
									}

									tvItem.hItem = TreeView_GetNextSibling(hTreeView,tvItem.hItem);
								}

								InvalidateRect(hTreeView,NULL,true);
								UpdateWindow(hTreeView);
								SetDlgItemText(hwndDlg,IDOK,Translate("OK"));
							}
							else
							{
								// apply settings
								SendMessage(hwndDlg,WM_USER+60,0,0);
							}
						} break;
//						default: CallService(MS_CLIST_MENUPROCESSCOMMAND,MAKEWPARAM(LOWORD(wParam),MPCF_CONTACTMENU),(LPARAM)dat->hLastContact); break;
					}
				} break;
				case EN_SETFOCUS: // focus was gained by combobox or msg data
				{
					if (LOWORD(wParam) == IDC_SAWAYMSG_MSGDATA)
					{
						SendMessage(hwndDlg,WM_USER+18,0,0); // reset counter
					}
				} break;
				case EN_CHANGE:
				{
					if (LOWORD(wParam) == IDC_SAWAYMSG_MSGDATA)
					{
						SendMessage(hwndDlg,WM_USER+35,0,0);
					}
				} break;
				case CBN_DROPDOWN:
				{
					if (LOWORD(wParam) == IDC_SAWAYMSG_MSGNAME)
					{
						SendMessage(hwndDlg,WM_USER+18,0,0); // reset counter
					}
				} break;
				case CBN_SELCHANGE: // user changed the selection, let's use a saved msg
				{
					if (LOWORD(wParam) == IDC_SAWAYMSG_MSGNAME)
					{
						SendMessage(hwndDlg,WM_USER+18,0,0); // reset counter
						
						int iSelect = SendDlgItemMessage(hwndDlg,IDC_SAWAYMSG_MSGNAME,CB_GETCURSEL,0,0); // get new msg num
						if (iSelect != CB_ERR)
						{
							char *lpszMsg = (char*)SendDlgItemMessage(hwndDlg,IDC_SAWAYMSG_MSGNAME,CB_GETITEMDATA,iSelect,0);
							if (lpszMsg != NULL) // got smt
								SetDlgItemText(hwndDlg,IDC_SAWAYMSG_MSGDATA,lpszMsg); // set the data
							else
							{
								char szTemp[1];
								szTemp[0] = '\0';
								SetDlgItemText(hwndDlg,IDC_SAWAYMSG_MSGDATA,szTemp);
							}
							SendMessage(hwndDlg,WM_USER+35,0,0);
						}
					}
					return(0);
				} break;
			}
		} break;
		case WM_USER + 35: // do some counting
		{
			LockWindowUpdate(GetDlgItem(hwndDlg,IDC_SAWAYMSG_STATIC_COUNTER)); // lock updating until we're done
			SetDlgItemInt(hwndDlg,IDC_SAWAYMSG_STATIC_COUNTER,SendDlgItemMessage(hwndDlg,IDC_SAWAYMSG_MSGDATA,WM_GETTEXTLENGTH,0,0),false);
			LockWindowUpdate(NULL);
		} break;
		case WM_SETCURSOR: // the mouse is moving
		{
			if (((HWND)wParam == GetDlgItem(hwndDlg,IDC_SAWAYMSG_STATIC_VARS)) || ((HWND)wParam == GetDlgItem(hwndDlg,IDC_SAWAYMSG_STATIC_RESETCHNG)))
			{
				SetCursor(g_hHandCursor);
				SetWindowLongPtr(hwndDlg,DWLP_MSGRESULT,true);
				return(true);
			}
		} break;
		case WM_CTLCOLORSTATIC:
		{
			if (((HWND)lParam == GetDlgItem(hwndDlg,IDC_SAWAYMSG_STATIC_VARS)) || ((HWND)lParam == GetDlgItem(hwndDlg,IDC_SAWAYMSG_STATIC_RESETCHNG)))
			{
				SetTextColor((HDC)wParam,RGB(0,0,120));
				SetBkMode((HDC)wParam,TRANSPARENT);
				return((INT_PTR)GetStockObject(NULL_BRUSH));
			}
			else if ((HWND)lParam == GetDlgItem(hwndDlg,IDC_SAWAYMSG_STATIC_COUNTER))
			{
				if (GetDlgItemInt(hwndDlg,IDC_SAWAYMSG_STATIC_COUNTER,NULL,false) == AWAY_PRED_DATA_MAX)
				{
					SetTextColor((HDC)wParam,RGB(120,0,0));
				}
				else
				{
					SetTextColor((HDC)wParam,RGB(0,120,0));
				}
				SetBkMode((HDC)wParam,TRANSPARENT);
				return((INT_PTR)GetStockObject(NULL_BRUSH));
			}
		} break;
		case WM_CLOSE:
		{
	//		DestroyWindow(hwndDlg);
			EndDialog(hwndDlg,1);
		} break;
		case WM_DESTROY:
		{
			// deallocate all data
			HWND hComboBox = GetDlgItem(hwndDlg,IDC_SAWAYMSG_MSGNAME);
			int iCount = SendMessage(hComboBox,CB_GETCOUNT,0,0);

			for (int index=0;index < iCount;index++)
			{
				char *lpszData = (char*)SendMessage(hComboBox,CB_GETITEMDATA,index,0);
				if (lpszData != NULL) // no (), just to be sure
					delete [] lpszData; // deallocate!
			}

			// this is where we delete temp stuff (rmsg, rsel) for all contacts and main contact
			// it was all processed before in WM_USER+60
			HANDLE hContact = (HANDLE)CallService(MS_DB_CONTACT_FINDFIRST,0,0);
			while (hContact != NULL)
			{
				DBDeleteContactSetting(hContact,MOD_NAME,"rmsg");
				DBDeleteContactSetting(hContact,MOD_NAME,"rsel");
				hContact = (HANDLE)CallService(MS_DB_CONTACT_FINDNEXT,(WPARAM)hContact,0);
			}
			DBDeleteContactSetting(NULL,MOD_NAME,"rmsg");
			DBDeleteContactSetting(NULL,MOD_NAME,"rsel");


			if (dat != NULL)
			{
				if (dat->hDrawFont != NULL)
				{
					DeleteObject(dat->hDrawFont);
				}
				UnhookEvent(dat->hContactHook);
				delete dat;
			}

			g_hWndAwayDlg = NULL;

			if (DBGetContactSettingByte(NULL,MOD_NAME,"sdlgpos",0) == 1) // save dialog position
			{
				RECT rcRect;
				GetWindowRect(hwndDlg,&rcRect);

				DBWriteContactSettingDword(NULL,MOD_NAME,"dlgposx",rcRect.left);
				DBWriteContactSettingDword(NULL,MOD_NAME,"dlgposy",rcRect.top);
			}
			
			SetWindowLongPtr(GetDlgItem(hwndDlg,IDC_SAWAYMSG_MSGDATA),GWL_WNDPROC,(LONG_PTR)g_OrigEditMsgProc);
			g_OrigEditMsgProc = NULL;
			return(0);
		} break;
	}
	return(0);
}

void WriteAwayMsgInDB(HANDLE hContact,char *str, WPARAM wParam, int options)
{
	/*
	// lParam
	// [1] = lmsg
	// [2] = rmsg
	// [3] = interpret
	// [4] = cmsg
	// exemple : 0110
	*/
	byte fUseLMEStat = DBGetContactSettingByte(NULL,MOD_NAME,"lmestat",0) == 1;
	bool SameMsg = false;
	DBVARIANT dbVarb;

	DBGetContactSetting(NULL,MOD_NAME,"rmsg1",&dbVarb); // get the more recent msg
	if (dbVarb.type == DBVT_ASCIIZ) // yippie 
	{
			SameMsg = ((strcmp(dbVarb.pszVal,str) == 0) ? true : false);
	}


	if(options >= 1000)
	{
		if (fUseLMEStat) // individ
			DBWriteContactSettingString(hContact,MOD_NAME,StatusModeToDbSetting(wParam,"lmsg"),str); // remember last msg
		else
			DBWriteContactSettingString(hContact,MOD_NAME,"lmsg",str); // remember last msg
		
		options -= 1000;
	}

	if(options >= 100 && hContact == NULL && SameMsg == false)
	{
		//recent msg
		DBVARIANT dbVar;
		char szLastMsg[AWAY_MSGDATA_MAX];

		strcpy(szLastMsg,str);

		//Get all rmsg
		for (int index=1;index <= AWAY_RMSG_MAX;index++)
		{
			
			char szSuffix[DB_SUFFIX_MAX];
			char szSetting[128];
			
			sprintf(szSuffix,"%d",index);
			strcpy(szSetting,"rmsg");
			strcat(szSetting,szSuffix);

			if(DBGetContactSetting(NULL,MOD_NAME,szSetting,&dbVar) == 0) //exist
			{
				if(dbVar.type == DBVT_ASCIIZ)
				{
					DBWriteContactSettingString(NULL,MOD_NAME,szSetting,szLastMsg);
					strcpy(szLastMsg,dbVar.pszVal);
				}
				else
				{
					DBDeleteContactSetting(NULL,MOD_NAME,szSetting);
					DBWriteContactSettingString(NULL,MOD_NAME,szSetting,szLastMsg);
					strcpy(szLastMsg,"");
				}
			}
			else
			{
				DBWriteContactSettingString(NULL,MOD_NAME,szSetting,szLastMsg);
				break;
			}
			
			DBFreeVariant(&dbVar);
		}

		options -= 100;
	}

	if(options >= 10)
	{
		Interpret_Message_Using_Variables_Plugin(hContact, str);
		Interpret_Message(wParam,str);

		options -= 10;
	}

	if(options >= 1)
	{
		DBWriteContactSettingString(hContact,"SRAway",StatusModeToDbSetting(wParam,"Msg"),str);
		
		if (fUseLMEStat) // individ
			DBWriteContactSettingString(hContact,MOD_NAME,StatusModeToDbSetting(wParam,"cmsg"),str); // remember last msg
		else
			DBWriteContactSettingString(hContact,MOD_NAME,"cmsg",str); // remember last msg
		
		options -= 1;
	}
}

static void Get_DynamicStatMsg(int iMode,HANDLE hContact,char *lpOutMsg) // get the msg (yeah!)
{
	// let's see the last msg set	
	DBVARIANT dbVar;
	bool fGotMsg = false;
	char cmsgName[64];

	// this function will be complicated later
	// hContact is the contact that requests the status message,
	bool fLMEStat = DBGetContactSettingByte(NULL,MOD_NAME,"lmestat",0) == 1;
	
	if(fLMEStat)
		strcpy(cmsgName,StatusModeToDbSetting(iMode,"cmsg"));
	else
		strcpy(cmsgName,"cmsg");

	if ((hContact != NULL) && (DBGetContactSetting(hContact,MOD_NAME,cmsgName,&dbVar) == 0))
	{
		fGotMsg = true;
	}
	else if (DBGetContactSetting(NULL,MOD_NAME,cmsgName,&dbVar) == 0)
	{
		fGotMsg = true;
	}

	if(!fGotMsg)
	{
		Get_Default_Message(NULL,lpOutMsg);
	}
	else
	{
		strcpy(lpOutMsg,dbVar.pszVal);
	}

	if(DBGetContactSettingDword(NULL,MOD_NAME,"ctime",0) == 0)
	{
		DBWriteContactSettingDword(NULL,MOD_NAME,"ctime",GetTickCount());
	}


	Post_Interpret_Message(lpOutMsg,hContact); // process dynamic vars

	DBFreeVariant(&dbVar);
}



int StatusMsgReq(WPARAM wParam,LPARAM lParam)
{
	// find the contact
	char szcProto[64];
	
	HANDLE hContact = (HANDLE)CallService(MS_DB_CONTACT_FINDFIRST,0,0);
	while (hContact != NULL)
	{
		//Chercher le protocole du contact
		//Si Protocole->UIN et qu'il y'a ICQ dans le protocole ...
		
  		strcpy(szcProto, (char *) CallService(MS_PROTO_GETCONTACTBASEPROTO, (WPARAM) hContact, 0));
		if(strstr(szcProto,"ICQ"))
		{
			if ((DWORD)DBGetContactSettingDword(hContact,szcProto,"UIN",0) == (DWORD)lParam)
			{
				break;
			}
		}
		hContact = (HANDLE)CallService(MS_DB_CONTACT_FINDNEXT,(WPARAM)hContact,0);
	}
	strcpy(szcProto, (char *) CallService(MS_PROTO_GETCONTACTBASEPROTO, (WPARAM) hContact, 0));

	int iMode = ICQStatusToGeneralStatus((byte)wParam);
	if ((hContact != NULL) && (DBGetContactSettingByte(hContact,MOD_NAME,"ignorereq",0)))
	{
		CallProtoService(szcProto,PS_SETAWAYMSG,iMode,(LPARAM)""); // read below
		return(0); // move along, sir
	}

	char szMsg[AWAY_MSGDATA_MAX+1];
	Get_DynamicStatMsg(iMode,hContact,szMsg);
	//MessageBox(NULL,szMsg, "null", NULL);
	CallProtoService(szcProto,PS_SETAWAYMSG,iMode,(LPARAM)szMsg); // no reason to change status message for all protocols... we only support ICQ.dll, other variations (ICQ2.dll etc.) can go to hell (there's no way to support them all since each instance will need its own hook up to a StatusMsgReq... hopefully this will change in Miranda v1.0 :))
	// if doesn't exist, we do shit (sux :Q)
	return(0);
}



int MirandaShutdown(WPARAM wParam,LPARAM lParam)
{
	if (g_hWndAwayDlg != NULL) // we got a dialog - kill it now
	{
		return(1);
	}
	else
	{
		return(0);
	}
}



int MsgEventAdded(WPARAM wParam,LPARAM lParam)
{
	// before doing anything, check the status type!
	char *szProto = (char*)CallService(MS_PROTO_GETCONTACTBASEPROTO,wParam,0);

	if (szProto == NULL)
	{
		return(0);
	}

	unsigned int iMode = CallProtoService(szProto,PS_GETSTATUS,0,0);

	// find status in list
	for (int iStatusPos = 0;iStatusPos < sizeof(statusModeList) / sizeof(statusModeList[0]);iStatusPos++)
	{
		if (iMode == statusModeList[iStatusPos]) // got it
		{
			break;
		}
	}

	// can't be, but we should make sure
	if (iStatusPos == (sizeof(statusModeList) / sizeof(statusModeList[0]))) // bah
	{
		return(0);
	}

	if (DBGetContactSettingDword(NULL,MOD_NAME,"nossm",SSM_DEFAULT) & (1 << iStatusPos)) // fine, let's ignore
	{
		return(0);
	}

	HANDLE hContact = (HANDLE)wParam;

	if (hContact == NULL) // if not around (need to make sure)
	{
		return(0);
	}

	// a lot of this code was taken from MegaHal's source code
	// and later was revised by looking at MsgExport & NewEventNotify plugins' source code
	DBEVENTINFO dbei;

	dbei.cbSize = sizeof(dbei);
	dbei.cbBlob = 0;
	dbei.pBlob = NULL;

	CallService(MS_DB_EVENT_GET,lParam,(LPARAM)&dbei);

	if (!(dbei.flags & DBEF_SENT)) // msg is not sent
	{
		DBWriteContactSettingWord(hContact,MOD_NAME,"msgnum",DBGetContactSettingWord(hContact,MOD_NAME,"msgnum",0) + 1); // more msgs
	}

	// let's see if this contact is an ICQ or MSN
	bool anICQContact = false;
	char szcProto[64];
	strcpy(szcProto, (char *) CallService(MS_PROTO_GETCONTACTBASEPROTO, (WPARAM) hContact, 0));
	if(strstr(szcProto,"ICQ"))
	{
		if(DBGetContactSettingDword(hContact,szcProto,"UIN",0) != 0)
			anICQContact = true;
	}

	if (((DBGetContactSettingByte(NULL,MOD_NAME,"sendnoicq",1)) && anICQContact) // an icq contact
		||
		((DBGetContactSettingByte(NULL,MOD_NAME,"sendtype",1)) && (DBGetContactSettingByte(hContact,MOD_NAME,"sendcount",0) == 1))) // send count
	{
		return(0);
	}

	// we're not sending msgs to this contact
	if ((!DBGetContactSettingByte(hContact,MOD_NAME,"sendmsg",0)) && (!DBGetContactSettingByte(NULL,MOD_NAME,"sendmsg",0)))
	{
		return(0);
	}

	if (DBGetContactSettingByte(hContact,MOD_NAME,"ignorereq",0)) // byebye
	{
		return(0);
	}

	if ((dbei.flags & DBEF_SENT)/* || (dbei.flags & DBEF_READ)*/ || ((dbei.eventType != EVENTTYPE_MESSAGE) && (dbei.eventType != EVENTTYPE_URL) && (dbei.eventType != EVENTTYPE_FILE)))
	{
		return(0);
	}

	WORD wEventFlags = DBGetContactSettingByte(NULL,MOD_NAME,"sendevent",0);
	if (((dbei.eventType == EVENTTYPE_MESSAGE) && (!(wEventFlags & SENDSMSG_EVENT_MSG))) || ((dbei.eventType == EVENTTYPE_URL) && (!(wEventFlags & SENDSMSG_EVENT_URL))) || ((dbei.eventType == EVENTTYPE_FILE) && (!(wEventFlags & SENDSMSG_EVENT_FILE))))
	{
		return(0);
	}

	// send count
	if (DBGetContactSettingByte(hContact,MOD_NAME,"sendcount",0) == 0)
	{
		DBWriteContactSettingByte(hContact,MOD_NAME,"sendcount",1);
	}

	char szMsg[AWAY_MSGDATA_MAX+1];

	Get_DynamicStatMsg(iMode,hContact,szMsg);

	// let's send this back
	if (DBGetContactSettingByte(hContact,MOD_NAME,"logsendedmsg",1)) // log
	{
		DBEVENTINFO dbeo={0};
		dbeo.cbSize=sizeof(dbeo);
		dbeo.eventType=EVENTTYPE_MESSAGE;
		dbeo.flags=DBEF_SENT;
		dbeo.szModule=(char*)CallService(MS_PROTO_GETCONTACTBASEPROTO,(WPARAM)hContact,0);
		dbeo.timestamp=time(NULL);
		dbeo.cbBlob=lstrlen(szMsg)+1;
		dbeo.pBlob=(PBYTE)szMsg;
		CallService(MS_DB_EVENT_ADD,(WPARAM)hContact,(LPARAM)&dbeo);
	}

	CallContactService(hContact,PSS_MESSAGE,0,(LPARAM)szMsg);
	return(0);
}

int AutoAway(WPARAM wParam,LPARAM lParam)
{
	// wParam - new
	// let's check if we handle this thingy
	PROTOCOLSETTINGEX** protoSettings;
	protoSettings = *(PROTOCOLSETTINGEX***)wParam;	
	if ((protoSettings == NULL) || (protoSettings[0]->szMsg == NULL) ) {
		return -1;
	}

	Delete_Settings(false,false,false,true);

	ChangeAllProtoMessages(protoSettings[0]->status,protoSettings[0]->szMsg);
	
	WriteAwayMsgInDB(NULL, protoSettings[0]->szMsg, protoSettings[0]->status, 0111);

	if(DBGetContactSettingDword(NULL,MOD_NAME,"ctime",0) == 0)
	{
		DBWriteContactSettingDword(NULL,MOD_NAME,"ctime",GetTickCount());
	}

	return(0);
}

int StatusChanged(WPARAM wParam,LPARAM lParam)
{
	// wParam - new

	// let's check if we handle this thingy
	DWORD dwProtoModeMsgFlags = 0;
	PROTOCOLDESCRIPTOR **proto;
	byte bLMEStat = DBGetContactSettingByte(NULL,MOD_NAME,"lmestat",0);

	int iProtoCount = 0;
	CallService(MS_PROTO_ENUMPROTOCOLS,(WPARAM)&iProtoCount,(LPARAM)&proto);
	for(int index = 0;index < iProtoCount;index++)
	{
		dwProtoModeMsgFlags |= CallProtoService(proto[index]->szName,PS_GETCAPS,PFLAGNUM_3,0); // get types
	}

	if (!(dwProtoModeMsgFlags & Proto_Status2Flag(wParam)))
	{
		return(0); // nahh
	}

	// let's delete all temp settings for all contacts
	Delete_Settings(false,false,false,true);

	if (g_fNoProcessing) // we're told not to do anything
	{
		g_fNoProcessing = false; // take it off
		return(0); // stop working
	}

	BOOL bScreenSaverRunning;
	SystemParametersInfo(SPI_GETSCREENSAVERRUNNING,0,&bScreenSaverRunning,FALSE);

	// find status in list
	for (int iStatusPos = 0;iStatusPos < sizeof(statusModeList) / sizeof(statusModeList[0]);iStatusPos++)
	{
		if (wParam == statusModeList[iStatusPos]) // got it
		{
			break;
		}
	}

	// can't be, but we should make sure
	if (iStatusPos == (sizeof(statusModeList) / sizeof(statusModeList[0]))) // bah
	{
		return(0);
	}

	if ((bScreenSaverRunning) || (DBGetContactSettingDword(NULL,MOD_NAME,"nodlgs",0) & (1 << iStatusPos))) // in case of error we assume pop
	{
		// get the last/default msg
		// in either case -> find a msg :)
		char szSMsg[AWAY_MSGDATA_MAX+1];

		if (DBGetContactSettingByte(NULL,MOD_NAME,"usedef",0) == 0)
		{
			DBVARIANT dbVar;
			int iRes;
			if (bLMEStat == 1) // individ
				iRes = DBGetContactSetting(NULL,MOD_NAME,StatusModeToDbSetting(wParam,"lmsg"),&dbVar);
			else
				iRes = DBGetContactSetting(NULL,MOD_NAME,"lmsg",&dbVar);

			if ((iRes == 0) && (dbVar.type == DBVT_ASCIIZ)) // ours alright!
				strcpy(szSMsg,dbVar.pszVal);
			else // default
				Get_Default_Message(NULL,szSMsg);
			DBFreeVariant(&dbVar);
		}
		else // get default
			Get_Default_Message(NULL,szSMsg);

		WriteAwayMsgInDB(NULL, szSMsg, wParam, 1111);

		if (lParam == NULL)
		{
			ChangeAllProtoMessages(wParam,szSMsg);
		}
		else // change status for an individual protocol
		{
			CallProtoService((char*)lParam,PS_SETAWAYMSG,wParam,(LPARAM)szSMsg);
		}
	}
	else
	{
		SetAwayMsgData *dat = new SetAwayMsgData;
		dat->statusMode = wParam;
		dat->hInitContact = NULL;
		dat->szProtocol = (char*)lParam;
		/*g_hWndAwayDlg = */
		if (DialogBoxParam(g_hInstance,MAKEINTRESOURCE(IDD_SETAWAYMSG),NULL,SetAwayMsgDlgProc,(LPARAM)dat) == 1) // we need to set it (a msg was not set)
		{
			char str[AWAY_MSGDATA_MAX+1];
			DBVARIANT dbVar;
			int iResult;
			
			if (bLMEStat == 1) // individ
				iResult = DBGetContactSetting(NULL,MOD_NAME,StatusModeToDbSetting(wParam,"lmsg"),&dbVar);
			else
				iResult = DBGetContactSetting(NULL,MOD_NAME,"lmsg",&dbVar);

			if (iResult) // no go, let's get the default
			{
				Get_Default_Message(NULL,str);
			}
			else
			{
				strcpy(str,dbVar.pszVal);
				DBFreeVariant(&dbVar);
			}

			WriteAwayMsgInDB(NULL, str, wParam, 0111);
		}
	}

	DBWriteContactSettingDword(NULL,MOD_NAME,"ctime",GetTickCount()); // remember current time (after "regular" vars)
	return(0);
}



int IconsChangedProc(WPARAM wParam,LPARAM lParam)
{
	if (g_hwndMoreOpts != NULL) // then notify it
	{
		SendMessage(g_hwndMoreOpts,WM_USER+20,0,0);
	}
	if (g_hWndAwayDlg != NULL) // then refresh list
	{
		InvalidateRect(GetDlgItem(g_hWndAwayDlg,IDC_SAWAYMSG_CONTACTSTREE),NULL,true);
		UpdateWindow(GetDlgItem(g_hWndAwayDlg,IDC_SAWAYMSG_CONTACTSTREE));
	}
	return(0);
}



int PreBuildContactMenu(WPARAM wParam,LPARAM lParam)
{
	char *szProto = (char*)CallService(MS_PROTO_GETCONTACTBASEPROTO,wParam,0);

	CLISTMENUITEM menuItem;
	memset(&menuItem,0,sizeof(menuItem));
	menuItem.cbSize = sizeof(menuItem);
	menuItem.flags = CMIM_FLAGS | CMIF_HIDDEN;

	if (szProto != NULL)
	{
		if (!CallProtoService(szProto,PS_GETCAPS,PFLAGNUM_2,0)) // got a few status modes
		{
			return(0);
		}
		WORD wMode = CallProtoService(szProto,PS_GETSTATUS,0,0);

		if (wMode != ID_STATUS_OFFLINE) // you can set a message for ANY status, except offline, of course
		{
			char szName[256];
			sprintf(szName,Translate("Set %s message for %s"),CallService(MS_CLIST_GETSTATUSMODEDESCRIPTION,wMode,0),CallService(MS_CLIST_GETCONTACTDISPLAYNAME,wParam,0));
			menuItem.pszName = szName;
			menuItem.flags |= CMIM_NAME;
			menuItem.flags &= ~CMIF_HIDDEN;
		}

		// okay now for the read stat msg item
		// this was also taken from Miranda's src code, practically the same
		CLISTMENUITEM clmi;
		char str[128];
		int status;

		ZeroMemory(&clmi,sizeof(clmi));
		clmi.cbSize = sizeof(clmi);
		clmi.flags = CMIM_FLAGS | CMIF_NOTOFFLINE | CMIF_HIDDEN;

		status=DBGetContactSettingWord((HANDLE)wParam,szProto,"Status",ID_STATUS_OFFLINE);
		wsprintf(str,Translate("Re&ad %s Message"),(char*)CallService(MS_CLIST_GETSTATUSMODEDESCRIPTION,status,0));
		clmi.pszName=str;
		if(CallProtoService(szProto,PS_GETCAPS,PFLAGNUM_1,0) & PF1_MODEMSGRECV) {
			if(CallProtoService(szProto,PS_GETCAPS,PFLAGNUM_3,0)&Proto_Status2Flag(status)){
				clmi.flags = CMIM_FLAGS | CMIM_NAME | CMIF_NOTOFFLINE | CMIM_ICON;
				clmi.hIcon = LoadSkinnedProtoIcon(szProto,status);
			}

		}
		CallService(MS_CLIST_MODIFYMENUITEM,(WPARAM)g_hReadStatMenuItem,(LPARAM)&clmi);
	}

	CallService(MS_CLIST_MODIFYMENUITEM,(WPARAM)g_hContactMenuItem,(LPARAM)&menuItem);
	return(0);
}



static int SetContactStatMsg(WPARAM wParam,LPARAM lParam)
{
	if (g_hWndAwayDlg != NULL) // we got a dialog - kill it now
	{
	//	DestroyWindow(g_hWndAwayDlg);
//		EndDialog(g_hWndAwayDlg,1);
		return(0);
	}
	SetAwayMsgData *dat = new SetAwayMsgData;
	dat->hInitContact = (HANDLE)wParam;
	dat->szProtocol = (char*)CallService(MS_PROTO_GETCONTACTBASEPROTO,wParam,0);
	dat->statusMode = CallProtoService(dat->szProtocol,PS_GETSTATUS,0,0);
	/*g_hWndAwayDlg = */DialogBoxParam(g_hInstance,MAKEINTRESOURCE(IDD_SETAWAYMSG),NULL,SetAwayMsgDlgProc,(LPARAM)dat);
	return(0);
}



static int SetStatusMode(WPARAM wParam,LPARAM lParam)
{
	char szMsg[AWAY_PRED_DATA_MAX+1];
	byte fLMEStat = DBGetContactSettingByte(NULL,MOD_NAME,"lmestat",0);

	if (lParam != NULL)
	{
		if (lstrlen((char*)lParam) > AWAY_PRED_DATA_MAX) // no more than this
		{
			strncpy(szMsg,(char*)lParam,AWAY_PRED_DATA_MAX);
			szMsg[AWAY_PRED_DATA_MAX] = '\0';
		}
		else
		{
			strcpy(szMsg,(char*)lParam);
		}
	}
	else // get a default msg
	{
		if (DBGetContactSettingByte(NULL,MOD_NAME,"usedef",0) == 0)
		{
			DBVARIANT dbVar;
			int iRes;
			if (fLMEStat) // individ
				iRes = DBGetContactSetting(NULL,MOD_NAME,StatusModeToDbSetting(wParam,"lmsg"),&dbVar);
			else
				iRes = DBGetContactSetting(NULL,MOD_NAME,"lmsg",&dbVar);

			if ((iRes == 0) && (dbVar.type == DBVT_ASCIIZ)) // ours alright!
				strcpy(szMsg,dbVar.pszVal);
			else // default
				Get_Default_Message(NULL,szMsg);
			DBFreeVariant(&dbVar);
		}
		else // get default
			Get_Default_Message(NULL,szMsg);
	}


	DBWriteContactSettingDword(NULL,MOD_NAME,"ctime",GetTickCount()); // remember current time (after "regular" vars)

	WriteAwayMsgInDB(NULL, szMsg, wParam, 0111);
	// remember current (after "regular" vars)
	
	// ok, make it so, scottie!
	ChangeAllProtoMessages(wParam,szMsg);

	if ((WPARAM)CallService(MS_CLIST_GETSTATUSMODE,0,0) != wParam) // not same status
	{
		g_fNoProcessing = true;
		CallService(MS_CLIST_SETSTATUSMODE,wParam,0);
	}
	return(0);
}

static int IgnoreNextStatusChange(WPARAM wParam,LPARAM lParam)
{
	g_fNoProcessing = true;
	return(0);
}


static INT_PTR CALLBACK ReadAwayMsgDlgProc(HWND hwndDlg,UINT msg,WPARAM wParam,LPARAM lParam)
{
	switch(msg)
	{
		case WM_INITDIALOG:
		{
			TranslateDialogDefault(hwndDlg);
			READAWAYMSGDATA *awayData = new READAWAYMSGDATA;
			SetWindowLongPtr(hwndDlg,GWLP_USERDATA,(LONG_PTR)awayData);
			awayData->hContact = (HANDLE)lParam;
			awayData->hAwayMsgEvent = HookEventMessage(ME_PROTO_ACK,hwndDlg,WM_USER+55);
			awayData->hSeq = (HANDLE)CallContactService(awayData->hContact,PSS_GETAWAYMSG,0,0);
			WindowList_Add(g_hWindowList,hwndDlg,awayData->hContact);

			char str[256],format[128];
			char *status, *contactName;
			char *szProto;
			contactName=(char*)CallService(MS_CLIST_GETCONTACTDISPLAYNAME,(WPARAM)awayData->hContact,0);
			szProto=(char*)CallService(MS_PROTO_GETCONTACTBASEPROTO,(WPARAM)awayData->hContact,0);
			status=(char*)CallService(MS_CLIST_GETSTATUSMODEDESCRIPTION,DBGetContactSettingWord(awayData->hContact,szProto,"Status",ID_STATUS_OFFLINE),0);
			GetWindowText(hwndDlg,format,sizeof(format));
			_snprintf(str,sizeof(str),format,status,contactName);
			SetWindowText(hwndDlg,str);
			GetDlgItemText(hwndDlg,IDC_READAWAYMSG_RETRIEVE,format,sizeof(format));
			_snprintf(str,sizeof(str),format,status);
			SetDlgItemText(hwndDlg,IDC_READAWAYMSG_RETRIEVE,str);
			return(true);
		} break;
		case WM_USER + 55: // got away msg
		{
			ACKDATA *ack = (ACKDATA*)lParam;
			READAWAYMSGDATA *awayData = (READAWAYMSGDATA*)GetWindowLongPtr(hwndDlg,GWLP_USERDATA);

			// make sure everything is ok, and this is our ack
			if ((ack->hContact != awayData->hContact) || (ack->type != ACKTYPE_AWAYMSG) || (ack->hProcess != awayData->hSeq) || (ack->result != ACKRESULT_SUCCESS))
			{
				break;
			}

			// done with the event
			if (awayData->hAwayMsgEvent)
			{
				UnhookEvent(awayData->hAwayMsgEvent);
				awayData->hAwayMsgEvent=NULL;
			}

			SetDlgItemText(hwndDlg,IDC_READAWAYMSG_MSG,(const char*)ack->lParam);
			ShowWindow(GetDlgItem(hwndDlg,IDC_READAWAYMSG_RETRIEVE),SW_HIDE);
			ShowWindow(GetDlgItem(hwndDlg,IDC_READAWAYMSG_MSG),SW_SHOW);
			SetDlgItemText(hwndDlg,IDOK,Translate("&Close"));
		} break;
		case WM_COMMAND:
		{
			switch (HIWORD(wParam))
			{
				case BN_CLICKED:
				{
					switch(LOWORD(wParam))
					{
						case IDCANCEL:
						case IDOK:
						{
							DestroyWindow(hwndDlg);
						} break;
					}
				} break;
			}
		} break;
		case WM_CLOSE:
		{
			DestroyWindow(hwndDlg);
		} break;
		case WM_DESTROY:
		{
			READAWAYMSGDATA *awayData = (READAWAYMSGDATA*)GetWindowLongPtr(hwndDlg,GWLP_USERDATA);
			if (awayData->hAwayMsgEvent)
			{
				UnhookEvent(awayData->hAwayMsgEvent);
				awayData->hAwayMsgEvent=NULL;
			}
			delete awayData;
			WindowList_Remove(g_hWindowList,hwndDlg);
		} break;
	}
	return(false);
}



int GetContactStatMsg(WPARAM wParam,LPARAM lParam)
{
	if (HWND hWnd = WindowList_Find(g_hWindowList,(HANDLE)wParam)) // already have it
	{
		SetForegroundWindow(hWnd);
		SetFocus(hWnd);
	}
	else
	{
		CreateDialogParam(g_hInstance,MAKEINTRESOURCE(IDD_READAWAYMSG),NULL,ReadAwayMsgDlgProc,wParam);
	}
	return(0);
}


void UpdateSOEButtons(int SendOnEventActived)
{
	CLISTMENUITEM mi;
	
	if (ServiceExists(MS_TTB_SETBUTTONSTATE))
	{
		//MS_TTB_SETBUTTONOPTIONS	
		CallService(MS_TTB_SETBUTTONSTATE, (WPARAM)g_hTopToolbarbutton, (SendOnEventActived) ? (TTBST_PUSHED) : (TTBST_RELEASED));
	}

	ZeroMemory(&mi, sizeof(mi));
	mi.cbSize = sizeof(mi);
	mi.position = 1000020000;
	mi.flags=CMIM_FLAGS|CMIM_NAME|CMIF_NOTOFFLINE|CMIM_ICON;
	mi.hIcon = LoadIcon(g_hInstance, MAKEINTRESOURCE((SendOnEventActived) ? (IDI_SOE_ENABLED) : (IDI_SOE_DISABLED)));
	mi.pszName = (SendOnEventActived) ? (DISABLE_SOE_COMMAND) : (ENABLE_SOE_COMMAND);
	mi.pszService = MS_AWAYSYS_TOGGLESENDONEVENT;
	
	CallService(MS_CLIST_MODIFYMENUITEM,(WPARAM)g_hToggleSOEMenuItem,(LPARAM)&mi);
}

int ToggleSendOnEvent(WPARAM wParam, LPARAM lParam)
{
	int SendOnEventActived = DBGetContactSettingByte(NULL,MOD_NAME,"sendmsg",1);

	DBWriteContactSettingByte(NULL,MOD_NAME,"sendmsg",(SendOnEventActived) ? (0) : (1));
	SendOnEventActived = SendOnEventActived ^ 1;

	UpdateSOEButtons(SendOnEventActived);
	return 0;
}

int Create_TopToolbar(WPARAM wParam, LPARAM lParam)
{	
	int SendOnEventActived = DBGetContactSettingByte(NULL,MOD_NAME,"sendmsg",1);
		
	if (ServiceExists(MS_TTB_ADDBUTTON))
	{
		TTBButton ttbb;

		ZeroMemory(&ttbb, sizeof(ttbb));
      	ttbb.cbSize = sizeof(ttbb);
		ttbb.hbBitmapUp = LoadBitmap(g_hInstance, MAKEINTRESOURCE(IDB_SOE_DISABLED));
		ttbb.hbBitmapDown = LoadBitmap(g_hInstance, MAKEINTRESOURCE(IDB_SOE_ENABLED));
		ttbb.pszServiceUp = MS_AWAYSYS_TOGGLESENDONEVENT;
		ttbb.pszServiceDown = MS_AWAYSYS_TOGGLESENDONEVENT;

		g_hTopToolbarbutton = (HANDLE)CallService(MS_TTB_ADDBUTTON, (WPARAM)&ttbb, 0);
		CallService(MS_TTB_SETBUTTONSTATE, (WPARAM)g_hTopToolbarbutton,  (SendOnEventActived) ? (TTBST_PUSHED) : (TTBST_RELEASED));
	}
	
	return 0;
}

int Create_Menuitem(void)
{
	CLISTMENUITEM mi;

	int SendOnEventActived = DBGetContactSettingByte(NULL,MOD_NAME,"sendmsg",1);

	ZeroMemory(&mi, sizeof(mi));
	mi.cbSize = sizeof(mi);
	mi.position = 1000020000;
	mi.flags=CMIM_FLAGS|CMIM_NAME|CMIF_NOTOFFLINE|CMIM_ICON;
	mi.hIcon = LoadIcon(g_hInstance, MAKEINTRESOURCE((SendOnEventActived) ? (IDI_SOE_ENABLED) : (IDI_SOE_DISABLED)));
	mi.pszName = (SendOnEventActived) ? (DISABLE_SOE_COMMAND) : (ENABLE_SOE_COMMAND);
	mi.pszService = MS_AWAYSYS_TOGGLESENDONEVENT;
	
	g_hToggleSOEMenuItem = (HANDLE)CallService(MS_CLIST_ADDMAINMENUITEM, 0, (LPARAM)&mi);
	
	return 0;
}


int MirandaLoaded(WPARAM wParam,LPARAM lParam)
{
	PROTOCOLDESCRIPTOR **proto;

	// this piece of code is "inspired" by Miranda's SRAway module code that checks
	// for status messages support from protocols.
	int iProtoCount = 0;
	CallService(MS_PROTO_ENUMPROTOCOLS,(WPARAM)&iProtoCount,(LPARAM)&proto);
	for(int index = 0;index < iProtoCount;index++)
	{
		if (CallProtoService(proto[index]->szName,PS_GETCAPS,PFLAGNUM_3,0))
		{
			break;
		}
	}

	if (index != iProtoCount) // hook on
	{
		CreateServiceFunction(MS_AWAYSYS_SETCONTACTSTATMSG,SetContactStatMsg);
		CreateServiceFunction(MS_AWAYSYS_SETSTATUSMODE,SetStatusMode);
		CreateServiceFunction(MS_AWAYSYS_IGNORENEXT,IgnoreNextStatusChange);
		CreateServiceFunction(MS_AWAYSYS_TOGGLESENDONEVENT, ToggleSendOnEvent);
		
		g_hmToolbarLoaded = HookEvent(ME_TTB_MODULELOADED,Create_TopToolbar);
		g_hmOptInit = HookEvent(ME_OPT_INITIALISE,OptsDlgInit);
		g_hmStatChange = HookEvent(ME_CLIST_STATUSMODECHANGE,StatusChanged);
		g_hmIdleChange = HookEvent("CommonStatus/StatusChangeEx"/*"AdvancedAutoAway/StateChanged"*/,AutoAway);
		g_hmStatMsgReq = HookEvent(ME_ICQ_STATUSMSGREQ,StatusMsgReq);
		g_hmEventAdd = HookEvent(ME_DB_EVENT_ADDED,MsgEventAdded);
		g_hmShutdown = HookEvent(ME_SYSTEM_OKTOEXIT,MirandaShutdown);
		g_hmIconsChanged = HookEvent(ME_SKIN_ICONSCHANGED,IconsChangedProc);
		g_hmPreBuildMenu = HookEvent(ME_CLIST_PREBUILDCONTACTMENU,PreBuildContactMenu);

		g_hWindowList = (HANDLE)CallService(MS_UTILS_ALLOCWINDOWLIST,0,0);

		// start setting settings
		Check_Settings();

		//Add menu item
		Create_Menuitem();

		// only if we have to
		if (DBGetContactSettingByte(NULL,MOD_NAME,"enablemi",1))
		{
			// let's setup the contact menu item
			CLISTMENUITEM menuItem;
			ZeroMemory(&menuItem,sizeof(menuItem));
			menuItem.cbSize = sizeof(menuItem);
			menuItem.flags = CMIF_HIDDEN;
			menuItem.pszName = "Away System"; // will never be shown
			menuItem.position = 1000020000;
			menuItem.hIcon = LoadIcon(g_hInstance,MAKEINTRESOURCE(IDI_MSGICON));
			menuItem.pszService = MS_AWAYSYS_SETCONTACTSTATMSG;
			g_hContactMenuItem = (HANDLE)CallService(MS_CLIST_ADDCONTACTMENUITEM,0,(LPARAM)&menuItem);
		}

		// add that funky thingy (just tweaked a bit, was spotted in Miranda's src code)
		// we have to read the status message from contacts too... err
		CreateServiceFunction(MS_AWAYMSG_SHOWAWAYMSG,GetContactStatMsg);

		CLISTMENUITEM mi;
		ZeroMemory(&mi,sizeof(mi));
		mi.cbSize = sizeof(mi);
		mi.position = -2000005000;
		mi.flags = CMIF_NOTOFFLINE | CMIF_HIDDEN;
		mi.hIcon = NULL;
		mi.pszContactOwner = NULL;
		mi.pszName = "Phear the monkey!"; // never seen...
		mi.pszService = MS_AWAYMSG_SHOWAWAYMSG;
		g_hReadStatMenuItem = (HANDLE)CallService(MS_CLIST_ADDCONTACTMENUITEM,0,(LPARAM)&mi);
	}
	return(0);
}



extern "C" int __declspec(dllexport) Load(PLUGINLINK *link)
{
	pluginLink = link;
	DBVARIANT dbv;

	InitCommonControls();

	g_hmModLoad = HookEvent(ME_SYSTEM_MODULESLOADED,MirandaLoaded);
	srand(GetTickCount());

	OSVERSIONINFO osVers;
	osVers.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osVers);

	if(DBGetContactSetting(NULL, "KnownModules", "Away System Modification", &dbv))
        DBWriteContactSettingString(NULL, "KnownModules", "Away System Modification", "AwaySys");
    else
        DBFreeVariant(&dbv);

	if ((osVers.dwMajorVersion == 5) || ((osVers.dwMajorVersion == 4) && ((osVers.dwMinorVersion == 10) || (osVers.dwMinorVersion == 90))))
	{
		g_hHandCursor = LoadCursor(NULL,IDC_HAND);
	}
	else
	{
		g_hHandCursor = LoadCursor(g_hInstance,MAKEINTRESOURCE(IDC_MYHAND));
	}
	return(0);
}



extern "C" int __declspec(dllexport) Unload(void)
{
	// nice boys always unhook events :)
	UnhookEvent(g_hmPreBuildMenu);
	UnhookEvent(g_hmIconsChanged);
	UnhookEvent(g_hmShutdown);
	UnhookEvent(g_hmEventAdd);
	UnhookEvent(g_hmStatChange);
	UnhookEvent(g_hmIdleChange); //Auto-Away
	UnhookEvent(g_hmOptInit);
	UnhookEvent(g_hmModLoad);
	UnhookEvent(g_hmToolbarLoaded);

	if (g_hmStatMsgReq != NULL)
	{
		UnhookEvent(g_hmStatMsgReq);
	}
	return(0);
}