/*
	Away System Modification - A new Away System for Miranda IM
	Copyright (C) 2004-2005 Iksaif Entertainment
	Copyright (C) 2002-2003 Goblineye Entertainment

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#pragma once

#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <commctrl.h>
#include <time.h>
#include "AggressiveOptimize.h"
#include "resource.h"
#include "../../miranda32/random/plugins/newpluginapi.h"
#include "../../miranda32/ui/contactlist/m_clist.h"
#include "../../miranda32/core/m_system.h"
#include "../../miranda32/database/m_database.h"
#include "../../miranda32/ui/clui/m_clui.h"
#include "../../miranda32/random/langpack/m_langpack.h"
#include "../../miranda32/protocols/protocols/m_protosvc.h"
#include "../../miranda32/ui/options/m_options.h"
#include "../../protocols/icqoscar8/icq_constants.h"
#include "../../miranda32/random/skin/m_skin.h"
#include "../../miranda32/random/plugins/m_plugins.h"
#include "../../miranda32/sendrecv/awaymsg/m_awaymsg.h"
#include "../../miranda32/random/utils/m_utils.h"

#include "m_variables.h"
#include "m_toptoolbar.h"


typedef unsigned char byte;
#pragma comment(lib,"comctl32.lib")

#define SENDSMSG_EVENT_MSG 0x1
#define SENDSMSG_EVENT_URL 0x2
#define SENDSMSG_EVENT_FILE 0x4

#define AWAY_DF_TITLE "Not here"
#define AWAY_DF_MSG "Gone since %time%, will be back later."

#define AWAY_RMSG_MAX 5
#define AWAY_TITLE_MAX 24
#define AWAY_PRED_NAME_MAX 64
#define AWAY_PRED_DATA_MAX 1024
#define DB_SUFFIX_MAX 8

#define AWAY_MSGDATA_MAX 4096

#define TOGGLE_SOE_COMMAND "Send Away Msg on/off"
#define DISABLE_SOE_COMMAND "Don't Send Away Msg on event"
#define ENABLE_SOE_COMMAND "Send Away Msg on event"

const char SETAWAYDLG_LASTMSGTITLE[] =  "-> Last%sMessage";
const char SETAWAYDLG_SHOWRMSG[] = "-- Recent --";

int ICQStatusToGeneralStatus(byte bICQStat);

static WORD statusModeList[]={ID_STATUS_OFFLINE,ID_STATUS_ONLINE,ID_STATUS_AWAY,ID_STATUS_NA,ID_STATUS_OCCUPIED,ID_STATUS_DND,ID_STATUS_FREECHAT,ID_STATUS_INVISIBLE,ID_STATUS_ONTHEPHONE,ID_STATUS_OUTTOLUNCH};
#define SSM_DEFAULT 0x83

#define MOD_NAME "AwaySys"
#define MS_AWAYSYS_SETCONTACTSTATMSG "AwaySys/SetContactStatMsg"
#define ME_ICQ_STATUSMSGREQ "ICQ/StatusMsgReq" // can't use the define from m_icq.h, the stupid workaround that lets you use several ICQ accounts at once is stupid! yeah :)

#define MS_AWAYSYS_SETSTATUSMODE "AwaySys/SetStatusMode" // change the status mode. wParam is new mode, lParam is new status message (AwaySys will interpret variables out of it), may be NULL.
#define MS_AWAYSYS_IGNORENEXT "AwaySys/IgnoreNextStatusChange" //ignore nest status change
#define MS_AWAYSYS_TOGGLESENDONEVENT "AwaySys/ToggleSendOnEvent"

typedef struct SetAwayMsgData_type {
	int statusMode;
	char *szProtocol; // still in StatusChange
	int countdown;
	char okButtonFormat[64];
	char titleFormat[128];
	HFONT hDrawFont; // drawing font... :)
	HANDLE hContactHook; // a hook :)
	HANDLE hInitContact; // initial contact (filled by caller)
	bool fFullSize; // what's our current size?
//	HANDLE hLastContact;
	unsigned short s_iFullW, s_iShortW;
	unsigned short s_iFullH, s_iShortH;
} SetAwayMsgData;

typedef struct READAWAYMSGDATA_TYPE
{
	HANDLE hContact; // contact
	HANDLE hSeq; // sequence for stat msg request
	HANDLE hAwayMsgEvent; // hooked
} READAWAYMSGDATA;

typedef struct ENUMMSGS_DATA_TYPE
{
	HWND hComboBox; // handle to the combobox control
	int iDefMsg; // in: def msg (that we have), out: def msg in combobox
}	ENUMMSGS_DATA;

typedef struct {
	int cbSize;
	char *szName;	// pointer to protocol modulename
	char *szMsg;	// pointer to the status message (may be NULL)
	WORD status;	// the status
	WORD lastStatus;// last status
} PROTOCOLSETTINGEX;

extern HINSTANCE g_hInstance;
extern HWND g_hwndMoreOpts;

void Disable_ChildWindows(HWND hwndParent);

int EnumMsgs(const char *szSetting,LPARAM lParam);
int EnumLastMsgs(const char *szSetting,LPARAM lParam);
int CALLBACK OptDlgMain(HWND hwndDlg,UINT msg,WPARAM wParam,LPARAM lParam);
INT_PTR CALLBACK VarsListDlgProc(HWND hwndDlg,UINT msg,WPARAM wParam,LPARAM lParam);
int OptsDlgInit(WPARAM wParam,LPARAM lParam);
int Delete_Settings(bool bDelOpts,bool bDelMore,bool bDelLastMsg,bool fContactTempSets); // fcontacts
int Check_Settings(void);

//char *GetAwayMessage(int statusMode);
void ChangeAllProtoMessages(int statusMode,char *msg);
char *StatusModeToDbSetting(int status,const char *suffix);
int Get_Default_Message(char *lpszTitle,char *lpszMsg);
void Interpret_Message(int iStatMode,char *lpszMsg);
void Interpret_Message_Using_Variables_Plugin(HANDLE hContact, char *szRcvdMsg);
void Post_Interpret_Message(char *lpszMsg,HANDLE hContact); // post interpretation (dynamic variables)
void WriteAwayMsgInDB(HANDLE hContact,char *str, WPARAM wParam, int options ); //Set Away Msg

//buttons
void UpdateSOEButtons(int SendOnEventActived);
int ToggleSendOnEvent(WPARAM wParam, LPARAM lParam);
int Create_TopToolbar(WPARAM wParam, LPARAM lParam);
int Create_Menuitem(void);